<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Channel extends wm3Section
  {

   function __construct() { }   

   public static function getSectionParameters()
    {
     // Set the right parameters for channel section
     return array(
                  'allowed_section'               => WM3_cSECTION_CHANNELS,
                  'allow_category_description'    => false,
                  'allow_subcategory_description' => false,
                  'category_form'                 => 'admin_channel_category_form.inc',
                  'search_form'                   => 'admin_channel_search_form.inc',
                  'subcategory_form'              => 'admin_channel_subcategory_form.inc',
                  'table_categories'              => '_channels_categories',
                  'table_subcategories'           => '_channels_subcategories',
                  'table_subcategories_count'     => '_channels_subcategories',
                  'table_items_count'             => '_channels_blocks',
                  'action_save_category'          => WM3_cACTION_SAVE_CHANNEL_CATEGORY,
                  'action_update_category'        => WM3_cACTION_UPDATE_CHANNEL_CATEGORY,
                  'action_show_subcategory'       => WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY,
                  'action_add_subcategory'        => WM3_cACTION_ADD_CHANNEL_SUBCATEGORY,
                  'action_disable_category'       => WM3_cACTION_DISABLE_CHANNEL_CATEGORY,
                  'action_enable_category'        => WM3_cACTION_ENABLE_CHANNEL_CATEGORY,
                  'action_edit_category'          => WM3_cACTION_EDIT_CHANNEL_CATEGORY,
                  'action_delete_category'        => WM3_cACTION_DELETE_CHANNEL_CATEGORY,
                  'action_update_subcategory'     => WM3_cACTION_UPDATE_CHANNEL_SUBCATEGORY,
                  'action_save_subcategory'       => WM3_cACTION_SAVE_CHANNEL_SUBCATEGORY,
                  'action_show_items'             => WM3_cACTION_SHOW_CHANNEL_BLOCK,
                  'action_add_item'               => WM3_cACTION_ADD_CHANNEL_BLOCK,
                  'action_disable_subcategory'    => WM3_cACTION_DISABLE_CHANNEL_SUBCATEGORY,
                  'action_enable_subcategory'     => WM3_cACTION_ENABLE_CHANNEL_SUBCATEGORY,
                  'action_edit_subcategory'       => WM3_cACTION_EDIT_CHANNEL_SUBCATEGORY,
                  'action_delete_subcategory'     => WM3_cACTION_DELETE_CHANNEL_SUBCATEGORY,
                  'action_search'                 => WM3_cACTION_SHOW_CHANNEL_BLOCK,
                  'label_category_list_title'     => 953,
                  'label_subcategory_add'         => 1663,
                  'label_subcategories_count'     => 1690,
                  'label_items_count'             => 1692,
                  'label_item_add'                => 954,
                  'label_add_category_title'      => 353,
                  'label_edit_category_title'     => 148,
                  'label_add_subcategory_title'   => 353,
                  'label_edit_subcategory_title'  => 154);
    }

   public static function getChannelBlockFieldsArray()
    {
     return array('blockID','title','subcategoryID','block_type',
				  'pageID','ts','subchannelID',
	              'picture','picture_align','alt','render_mode','description','enabled','languageID','linkID','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_CHANNEL_CATEGORY:
        {
         return wm3Channel::addChannelCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_CHANNEL_CATEGORY:
        {
         $error = wm3Channel::checkChannelCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Channel::saveChannelCategory($w3);
           // $msg= message saved... //TODO
           return wm3Channel::getChannelCategoryList($w3,$lastID);
          }
         else return wm3Channel::addChannelCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_CHANNEL_CATEGORY:
        {
         return wm3Channel::editChannelCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_CHANNEL_CATEGORY:
        {
         $error = wm3Channel::checkChannelCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Channel::updateChannelCategory($w3);
           // $msg= message udated... //TODO
           return wm3Channel::getChannelCategoryList($w3,$lastID);
          }
         else return wm3Channel::editChannelCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_CHANNEL_CATEGORY:
        {
         wm3Channel::disableChannelCategory($w3->getVariable('categoryID','get'));
         return wm3Channel::getChannelCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHANNEL_CATEGORY:
        {
         wm3Channel::enableChannelCategory($w3->getVariable('categoryID','get'));
         return wm3Channel::getChannelCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHANNEL_CATEGORY:
        {
         wm3Channel::deleteChannelCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Channel::getChannelCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_CHANNEL_SUBCATEGORY:
        {
         return wm3Channel::addChannelSubcategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_CHANNEL_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_channels_categories    WRITE");
         $error = wm3Channel::checkChannelSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Channel::saveChannelSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Channel::getChannelSubcategoryList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Channel::addChannelSubcategory($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_DISABLE_CHANNEL_SUBCATEGORY:
        {
         wm3Channel::disableChannelSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Channel::getChannelSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHANNEL_SUBCATEGORY:
        {
         wm3Channel::enableChannelSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Channel::getChannelSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHANNEL_SUBCATEGORY:
        {
         wm3Channel::deleteChannelSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Channel::getChannelSubcategoryList($w3);
         break;
        }
       case WM3_cACTION_EDIT_CHANNEL_SUBCATEGORY:
        {
         return wm3Channel::editChannelSubcategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_CHANNEL_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_channels_categories    WRITE");
         $error = wm3Channel::checkChannelSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Channel::updateChannelSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Channel::getChannelSubcategoryList($w3,$lastID);
                     }
         else        {
                      wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Channel::editChannelSubcategory($w3,$error);
	                 }
         break;
        }
       case WM3_cACTION_ADD_CHANNEL_BLOCK:
        {
         return wm3Channel::addChannelBlock($w3);
         break;
        }
       case WM3_cACTION_SAVE_CHANNEL_BLOCK:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_channels_blocks        WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_channels_categories    WRITE");
         $error = wm3Channel::checkChannelBlockError($w3);
         if(!$error) {
                      $lastID = wm3Channel::saveChannelBlock($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Channel::getChannelBlockList($w3,$lastID);
                     }
         else        {
                      wm3Sql::sqlQuery("UNLOCK TABLES");
		              return wm3Channel::addChannelBlock($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_EDIT_CHANNEL_BLOCK:
        {
         return wm3Channel::editChannelBlock($w3);
         break;
        }
       case WM3_cACTION_UPDATE_CHANNEL_BLOCK:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_channels_blocks        WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_channels_categories    WRITE");
         $error = wm3Channel::checkChannelBlockError($w3);
         if(!$error) {
                      $lastID = wm3Channel::updateChannelBlock($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Channel::getChannelBlockList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Channel::editChannelBlock($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_DISABLE_CHANNEL_BLOCK:
        {
         wm3Channel::disableChannelBlock($w3->getVariable('blockID','get'));
         return wm3Channel::getChannelBlockList($w3,$w3->getVariable('blockID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHANNEL_BLOCK:
        {
         wm3Channel::enableChannelBlock($w3->getVariable('blockID','get'));
         return wm3Channel::getChannelBlockList($w3,$w3->getVariable('blockID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHANNEL_BLOCK:
        {
         wm3Channel::deleteChannelBlock($w3->getVariable('blockID','get'));
         return wm3Channel::getChannelBlockList($w3);
         break;
        }
    /*   case WM3_cACTION_DUPLICATE_CHANNEL_BLOCK:
        {
         $lastID = wm3Channel::duplicateChannel($w3);
         // $msg= message duplicated... //TODO
         return wm3Channel::getChannelBlockList($w3,$lastID);
         break;
        }*/
       case WM3_cACTION_SHOW_CHANNEL_BLOCK:
        {
         return wm3Channel::getChannelBlockList($w3);
         break;
        }
       case WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY:
        {
         return wm3Channel::getChannelSubcategoryList($w3);
         break;
        }
       default:
        {
         return wm3Channel::getChannelCategoryList($w3);
        }
      }     
    }

   public static function renderChannelBlocks($w3)
    {
     // Render blocks list for a subchannel (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_CHANNELS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subchannelID','both');
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID = '$subcategoryID'"; else $query_filter = " AND 1=0";
     $pg     = $w3->getVariable('pg','both');
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $width_title      = 100;
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.languageID='".$w3->getHomeLanguage()."'";
     if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_CHANNELS;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.description DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_channels_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) {
		                    $title = "&nbsp;"; $content = $w3->getWord(593);
	                        require($w3->getSkinObj()->getChannelBlockNoPicture()); 
	                       }

     // Channel blocks list
     while($row = mysql_fetch_object($rs))
      {
       $link = $base_link.$extra_link."&blockID=$row->blockID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       if($allowed) {
       	             $allowed_link = $base_allowed_link."&blockID=$row->blockID";
                     $allowed_button = " ".wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHANNEL_BLOCK,"action_edit.png",$w3->getWord(178));
                    }
       else          $allowed_button = "";

       // Render blocks
       if($row->block_type == WM3_cCHANNEL_BLOCK_TYPE_PAGE)
	    {
         $title   = wm3Page::makePageLink($row->linkID,$row->title).$allowed_button;
		 $picture = wm3Page::makePageLink($row->linkID,"<img src=\"".WM3_cPATH_IMAGES."$row->picture\" width=\"120\" height=\"90\" alt=\"$row->alt\" title=\"$row->alt\" border=\"0\">");
	    }
       else
	    {
		 $title   = wm3Channel::makeChannelBlockLink(WM3_cCONFIG_HOME_FILE,$row->linkID,$row->title).$allowed_button;
		 $picture = wm3Channel::makeChannelBlockLink(WM3_cCONFIG_HOME_FILE,$row->linkID,"<img src=\"".WM3_cPATH_IMAGES."$row->picture\" width=\"120\" height=\"90\" alt=\"$row->alt\" title=\"$row->alt\" border=\"0\">");
		}

       $content = wm3Util::renderContent($w3,$row->description,$row->render_mode);
       //$content = "&nbsp;".$row->description;
	   if($row->picture_align == WM3_cALIGN_LEFT)  require($w3->getSkinObj()->getChannelBlockLeftPicture());
	   if($row->picture_align == WM3_cNO_IMAGE)    require($w3->getSkinObj()->getChannelBlockNoPicture());
	   if($row->picture_align == WM3_cALIGN_RIGHT) require($w3->getSkinObj()->getChannelBlockRightPicture());
      }

     // Create page navigator
     if($total_items > $max_page_items) // TODO
      {
       $bottom = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&subchannelID=$subcategoryID");
       require($w3->getSkinObj()->getNewsBottom());
      }
    }

   public static function getChannelCategoryList($w3,$currentID = 0,$admin = true)
    {
   	 return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
   	}

   public static function checkChannelCategoryError($w3)
    {
     return $w3->getSectionObj()->checkCategoryError($w3);
    }

   public static function addChannelCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editChannelCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function saveChannelCategory($w3)
    {
     return $w3->getSectionObj()->saveCategory($w3);
    }

   public static function updateChannelCategory($w3)
    {
     return $w3->getSectionObj()->updateCategory($w3);
    }

   public static function disableChannelCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableChannelCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteChannelCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($categoryID);
    }

   public static function selectChannelCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
    }

   public static function getChannelCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($categoryID);
    }

   public static function getChannelSubcategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin);
    }

   public static function checkChannelSubcategoryError($w3)
    {
     return $w3->getSectionObj()->checkSubcategoryError($w3);
    }

   public static function addChannelSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addSubcategory($w3,$error);
    }

   public static function editChannelSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editSubcategory($w3,$error);
    }

   public static function saveChannelSubcategory($w3)
    {
     return $w3->getSectionObj()->saveSubcategory($w3);
    }

   public static function updateChannelSubcategory($w3)
    {
     return $w3->getSectionObj()->updateSubcategory($w3);
    }

   public static function disableChannelSubcategory($subcategoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories SET enabled = '".WM3_cDISABLED."' WHERE subcategoryID = '$subcategoryID'");
    }

   public static function enableChannelSubcategory($subcategoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories SET enabled = '".WM3_cENABLED."' WHERE subcategoryID = '$subcategoryID'");
    }
   
   public static function deleteChannelSubcategory($w3,$subcategoryID)
    {
     $w3->getSectionObj()->deleteSubcategory($subcategoryID);
    }

   public static function getChannelSubcategoryName($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getSubcategoryName($subcategoryID);
    }

   public static function selectChannelSubcategory($w3,$name,$subcategoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$name,$subcategoryID,$all,$admin);
    }

   public static function getChannelCategoryID($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getCategoryID($subcategoryID);
    }

   public static function duplicateChannelCategories($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '".$w3->getVariable('newsID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Channel::getChannelFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       //$_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $_FIELD['ts'] = time();
       //wm3Sql::saveAllTableFields('_news',$_FIELD,array('update_ts'));
       wm3Sql::saveAllTableFields('_news',$_FIELD);
       return wm3Sql::getLastInsertID();
      }
    }

   public static function getChannelBlockList($w3,$currentID = 0,$admin = true)
    {
     // Get channel block list

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_CHANNELS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subcategoryID','both');
     if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
      $categoryID = wm3Channel::getChannelCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.description LIKE '%$filter%'";
     	         }
     else        { if(!$subcategoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_title      = 70;
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_CHANNEL_BLOCK;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 6; $buttons = 3;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title      = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_CHANNELS;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.description DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_channels_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'blockID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_channel_search_form.inc");


     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(953)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(953)."</a>");
     if($subcategoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$categoryID)."</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$page_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$categoryID)."</a>");
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_CHANNEL_BLOCK,"action_add.png","","",$w3->getWord(954),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(50,50,0),array(194,1407),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&blockID=$row->blockID";
       if($allowed) $allowed_link = $base_allowed_link."&blockID=$row->blockID";
       if($subcategoryID) {
						   if($admin) array_push($_CONTENTS,$row->title);
				           else       array_push($_CONTENTS,"<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT.">$row->title</a>");
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           array_push($_CONTENTS,"$row->title<br>(".$w3->getWord(659)."
                           	                      <a href=\"".$base_link."&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$row->subcategoryID)."</a>)");
									  }
                           else       {
							           array_push($_CONTENTS,"<a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&subcategoryID=$row->subcategoryID&announcementID=$row->announcementID&action=".WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT."\">$row->title</a><br>(".$w3->getWord(659)."
                           	                      <a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$row->subcategoryID)."</a>)");
									  }
                          }
       array_push($_WIDTHS,$width_title);

       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag."<br>Linked to $row->block_type (page or channel block");
         array_push($_WIDTHS,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_CHANNEL_BLOCK,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_CHANNEL_BLOCK,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHANNEL_BLOCK,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHANNEL_BLOCK,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHANNEL_BLOCK,"action_edit.png",$w3->getWord(178)));
        }
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->blockID==$currentID);
	   $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkChannelBlockError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray());
     if($_FIELD['title']=='') return 1;
	 if(!$w3->getSectionObj()->existsSubcategory($_FIELD['subcategoryID'])) return 2;
     return 0;
    }

   public static function addChannelBlock($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Channel::getChannelBlockFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";

     // Hide/Show correct field and error
	 $_EXTRA_STYLE['pageID'] = $_EXTRA_STYLE['subchannelID'] = "style=\"display:none\"";
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $_EXTRA_STYLE['pageID']       = "";
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $_EXTRA_STYLE['subchannelID'] = "";

     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Subcategory do not exists
        {
         $_STYLE['subcategoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
         $form_title = "Invalid subcategory";//$w3->getWord(9);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']    = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['subcategoryID'] = $w3->getVariable('subcategoryID','get'); // Take subcategoryID from get
         $_FIELD['enabled']       = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(159);
       	}
      }
     $next_action = WM3_cACTION_SAVE_CHANNEL_BLOCK;
     $preview_image = $_FIELD['picture']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_IMAGES); // Set due preview image
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_channel_block_form.inc");
     return $content;
    }

   public static function editChannelBlock($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                               WHERE blockID = '".$w3->getVariable('blockID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Channel::getChannelBlockFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Channel::getChannelBlockFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');

     // Hide/Show correct field and error
	 $_EXTRA_STYLE['pageID'] = $_EXTRA_STYLE['subchannelID'] = "style=\"display:none\"";
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $_EXTRA_STYLE['pageID']       = "";
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $_EXTRA_STYLE['subchannelID'] = "";

     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Subcategory do not exists
        {
         $_STYLE['subcategoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
         $form_title = "Invalid subcategory";//$w3->getWord(9);
         break;
        }
       default:
        {
         if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       { $_FIELD['pageID']       = $_FIELD['linkID']; $_FIELD['subchannelID'] = ""; }
	     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) { $_FIELD['subchannelID'] = $_FIELD['linkID']; $_FIELD['pageID']       = ""; }

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(157);
       	}
      }
     $preview_image = $_FIELD['picture'];
     $next_action       = WM3_cACTION_UPDATE_CHANNEL_BLOCK;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_channel_block_form.inc");
     return $content;
    }

   public static function saveChannelBlock($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $_FIELD['linkID'] = $_FIELD['pageID'];
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $_FIELD['linkID'] = $_FIELD['subchannelID'];
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_channels_blocks',$_FIELD,array('pageID','subchannelID'));
     return wm3Sql::getLastInsertID();
    }

   public static function updateChannelBlock($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $linkID = $_FIELD['pageID'];
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $linkID = $_FIELD['subchannelID'];	 
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                       SET   title         = '".$_FIELD['title']."',
					         linkID        = '$linkID',
							 block_type    = '".$_FIELD['block_type']."',
							 picture       = '".$_FIELD['picture']."',
							 alt           = '".$_FIELD['alt']."',
							 description   = '".$_FIELD['description']."',
							 render_mode   = '".$_FIELD['render_mode']."',
							 picture_align = '".$_FIELD['picture_align']."',
                             subcategoryID = '".$_FIELD['subcategoryID']."',
                             enabled       = '".$_FIELD['enabled']."',
                             languageID    = '".$_FIELD['languageID']."'
                       WHERE blockID       = '".$_FIELD['blockID']."'");
     return $_FIELD['blockID'];
    }

   public static function disableChannelBlock($blockID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks SET enabled = '".WM3_cDISABLED."' WHERE blockID = '$blockID'"); }

   public static function enableChannelBlock($blockID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks SET enabled = '".WM3_cENABLED."' WHERE blockID = '$blockID'"); }
   
   public static function deleteChannelBlock($blockID)  { wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_channels_blocks WHERE blockID = '$blockID'"); }

   public static function getChannelBlockName($productID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                             WHERE productID = '$productID'");
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function makeChannelBlockLink($file,$blockID,$title,$css = "",$link_only = false)
    {
     // Make link for a channel block
	 if($link_only) return $file."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$blockID";
     return "<a $css href=\"".$file."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$blockID\">$title</a>";
    }

   public static function selectChannelBlockType($w3,$name,$block_type,$js = "")
    {
     // Make channel block type select
     return wm3Util::selectArray($name,
                        array($w3->getWord(1181),$w3->getWord(1182)),
                        array(WM3_cCHANNEL_BLOCK_TYPE_PAGE,WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL),
                        $block_type,
                        $js);
    }

   public static function renderChannels($w3)
    {
     // Render channels list for panel in home page

     // Prepare variables to create the list
     $columns = 2; $buttons = 0;

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_categories
               WHERE enabled = '".WM3_cENABLED."' AND languageID = '".$w3->getHomeLanguage()."'
               ORDER BY name";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // List items
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       array_push($_CONTENTS,$row->name); array_push($_WIDTHS,100);
       $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(2));
       $str .= wm3Channel::renderSubchannels($w3,$row->categoryID);
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderSubchannels($w3,$channelID)
    {
     // Render subchannels list for a channel (panel in home page)

     // Prepare variables to create the list
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_CHANNELS;
     $id_link = "";

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
               WHERE enabled = '".WM3_cENABLED."' AND categoryID = '$channelID' AND languageID = '".$w3->getHomeLanguage()."'
               ORDER BY ts";     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return wm3Section::makeEmptyItemsList($w3,$columns,593,true);

     // List items
     $p = 0; $str = "";
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link."&subchannelID=$row->subcategoryID";
       array_push($_CONTENTS,"&nbsp;","<a href=\"$link\">$row->name ></a>"); array_push($_WIDTHS,0,100);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     return $str;
    }

  }

?>
