<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3MenuBar
  {

   function __construct() { }

   public static function getMenuBarItemFieldsArray()
    {
     return array('menu_bar_itemID','title','position',
	              'categoryID','pageID','url','subchannelID','target','link_external_url','link_external_target','linkID',
				  'enabled','languageID','ts');
    }

   public static function makeMenuBarItemLink($row)
    {
     // Make a menu item for menu bar from a "_menu_bars_items" row's (passing a row perform a minor number of queries)
     $str = "";
     switch($row->categoryID)
      {
       case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:
        {
         $str .= wm3Page::makePageLink($row->linkID,$row->title);
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:
        {
         // TODO
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$row->linkID\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_HOME:
        {
         $str .= "<a href=\"".WM3_cCONFIG_HOME_FILE."\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_ADMIN:
        {
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_USER:
        {
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL:
        {
         $str .= "<a href=\"$row->url\" target=\"$row->target\">$row->title</a>";
         break;
        }
      }
     return $str;
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_MENU_BAR_ITEM:
        {
         wm3MenuBar::disableMenuBarItem($w3->getVariable('menu_bar_itemID','get'));
         return wm3MenuBar::getMenuBarItemList($w3,$w3->getVariable('menu_bar_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MENU_BAR_ITEM:
        {
         wm3MenuBar::enableMenuBarItem($w3->getVariable('menu_bar_itemID','get'));
         return wm3MenuBar::getMenuBarItemList($w3,$w3->getVariable('menu_bar_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MENU_BAR_ITEM:
        {
         wm3MenuBar::deleteMenuBarItem($w3->getVariable('menu_bar_itemID','get'));
         return wm3MenuBar::getMenuBarItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_MENU_BAR_ITEM:
        {
         return wm3MenuBar::addMenuBarItem($w3);
         break;
        }
       case WM3_cACTION_SAVE_MENU_BAR_ITEM:
        {
         $error = wm3MenuBar::checkMenuBarItemError($w3);
         if(!$error)
          {
           $lastID = wm3MenuBar::saveMenuBarItem($w3);
           // $msg= panel saved... //TODO
           return wm3MenuBar::getMenuBarItemList($w3,$lastID);
          }
         else return wm3MenuBar::addMenuBarItem($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_MENU_BAR_ITEM:
        {
         return wm3MenuBar::editMenuBarItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MENU_BAR_ITEM:
        {
         $error = wm3MenuBar::checkMenuBarItemError($w3);
         if(!$error)
          {
           $lastID = wm3MenuBar::updateMenuBarItem($w3);
           // $msg= panel udated... //TODO
           return wm3MenuBar::getMenuBarItemList($w3,$lastID);
          }
         else return wm3MenuBar::editMenuBarItem($w3,$error);
         break;
        }
       case WM3_cACTION_SWAP_MENU_BAR_ITEM:
        {
         wm3MenuBar::swapMenuBarItem($w3);
         return wm3MenuBar::getMenuBarItemList($w3,$w3->getVariable('menu_bar_itemID','get'));
         break;
        }
       default:
        {
         return wm3MenuBar::getMenuBarItemList($w3);
        }
      }
    }

   public static function getPositions()
    {
     // Create an array with menu item position
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                             ORDER BY position");
     $i = 1; $_MPOS['up'][0] = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_MPOS['up'][$i] = $_MPOS['down'][$i] = $row->menu_bar_itemID;
       $i++;
      }
     $m = $i-1; $_MPOS['down'][$i] = 0;
     for($i = $m;$i >= 1; $i--) $_MPOS['up'][$i]   = $_MPOS['up'][$i-1];
     for($i = 1;$i <= $m; $i++) $_MPOS['down'][$i] = $_MPOS['down'][$i+1];
     return $_MPOS;
    }

   public static function getPosition($menu_bar_itemID)
    {
     // Get the position of a menu item
     $rs = wm3Sql::sqlQuery("SELECT position FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                             WHERE menu_bar_itemID = '$menu_bar_itemID'");
     $row = mysql_fetch_object($rs);
     if($row) return $row->position;
    }

   public static function getMenuBarItemList($w3,$currentID = 0)
    {
     // Get menubar items list
     $columns = 8; $buttons = 3;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                        ORDER BY position";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord(174));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create list caption
	 $str .= wm3Section::makeCaptionList($w3,array(0,60,40,0),array(543,194,1407),$buttons,false,array(3));

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // List items
     $i = 1; $p = 0;
     $_MPOS = wm3MenuBar::getPositions();
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link."&menu_bar_itemID=$row->menu_bar_itemID";

       // Move panels up and down buttons and panel info
       array_push($_CONTENTS,$row->position);
       if($_MPOS['up'][$i]   == 0) array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">");
       else                        array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_MENU_BAR_ITEM."&swapID=".$_MPOS['up'][$i],"action_up.png",$w3->getWord(1279)));
       if($_MPOS['down'][$i] == 0) array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">");
       else                        array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_MENU_BAR_ITEM."&swapID=".$_MPOS['down'][$i],"action_down.png",$w3->getWord(1280)));
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\"> (".wm3MenuBar::getMenuBarItemCategoryName($row->categoryID,$w3).")";
       array_push($_CONTENTS,wm3MenuBar::makeMenuBarItemLink($row));
       array_push($_CONTENTS,$lang_flag);
       $i++;

       array_push($_WIDTHS,0,0,0,60,40);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_MENU_BAR_ITEM,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_MENU_BAR_ITEM,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MENU_BAR_ITEM,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_MENU_BAR_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(713)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->menu_bar_itemID==$currentID);
       $p++;       
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function checkMenuBarItemError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray());
     if($_FIELD['title']=='') return 1;
     if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM   && !$_FIELD['pageID'])            return 2;
     if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL  && !$_FIELD['subchannelID'])      return 3;
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL && !$_FIELD['link_external_url']) return 4;
     return 0;
    }

   public static function addMenuBarItem($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3MenuBar::getMenuBarItemFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray());

     // Hide/Show correct field and error
     $_EXTRA_STYLE['pageID'] = $_EXTRA_STYLE['subchannelID'] = $_EXTRA_STYLE['link_external_url'] = $_EXTRA_STYLE['link_external_target'] = "style=\"display:none\"";
     if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM || !$_FIELD['categoryID']) $_EXTRA_STYLE['pageID']       = "";
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL)                          $_EXTRA_STYLE['subchannelID'] = "";
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL)                         $_EXTRA_STYLE['link_external_url'] = $_EXTRA_STYLE['link_external_target'] = ""; 

     switch($error)
      {
       case 1: // No title 
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(166);
         break;
        }
       case 2: // No page defined when select custom category
        {
         $_STYLE['pageID']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(169);
         break;
        }
       case 3: // No channel block defined when select channel block category
        {
         $_STYLE['subchannelID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']    = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(168);
         break;
        }
       case 4: // Empty external url
        {
         $_STYLE['link_external_url'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']         = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(168);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(5);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_MENU_BAR_ITEM; 
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_menu_bar_item_form.inc");
     return $content;
    }

   public static function editMenuBarItem($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                               WHERE menu_bar_itemID = '".$w3->getVariable('menu_bar_itemID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3MenuBar::getMenuBarItemFieldsArray(),$row);
       // Default value for fields not in $row object
       switch($_FIELD['categoryID'])
        {
         case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:   { $_FIELD['pageID']       = $_FIELD['linkID']; $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; break; }
         case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:  { $_FIELD['subchannelID'] = $_FIELD['linkID']; $_FIELD['pageID']       = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; break; }
	     case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL: { $_FIELD['pageID'] = $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['url']; $_FIELD['link_external_target'] = $_FIELD['target']; break; }
         default: { $_FIELD['pageID'] = $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; }
        }
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3MenuBar::getMenuBarItemFieldsArray());

     // Hide/Show correct field and error
     $_EXTRA_STYLE['pageID'] = $_EXTRA_STYLE['subchannelID'] = $_EXTRA_STYLE['link_external_url'] = $_EXTRA_STYLE['link_external_target'] = "style=\"display:none\"";
     if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM || !$_FIELD['categoryID']) $_EXTRA_STYLE['pageID']       = "";
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL)                          $_EXTRA_STYLE['subchannelID'] = "";
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL)                         $_EXTRA_STYLE['link_external_url'] = $_EXTRA_STYLE['link_external_target'] = "";

     switch($error)
      {
       case 1: // No title 
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(166);
         break;
        }
       case 2: // No page defined when select custom category
        {
         $_STYLE['pageID']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(169);
         break;
        }
       case 3: // No channel block defined when select channel block category
        {
         $_STYLE['subchannelID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']    = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(168);
         break;
        }
       case 4: // Empty external url
        {
         $_STYLE['link_external_url'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']         = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(168);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(171);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_MENU_BAR_ITEM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_menu_bar_item_form.inc");
     return $content;
    }

   public static function saveMenuBarItem($w3)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");

     $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     switch($_FIELD['categoryID'])
      {
       case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:   { $_FIELD['linkID'] = $_FIELD['pageID'];  $_FIELD['url'] = $_FIELD['target'] = ''; break; }
       case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:  { $_FIELD['linkID'] = $_FIELD['subchannelID']; $_FIELD['url'] = $_FIELD['target'] = ''; break; }
	   case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['link_external_url']; $_FIELD['target'] = $_FIELD['link_external_target']; break; }
       default: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['target'] = ''; }
      }
     if($_FIELD['position'] <= 0) $_FIELD['position'] = 1; // If position its <= 0 (invalid position) the position will be 1
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                       SET position = position + 1
                       WHERE position >= '".$_FIELD['position']."'");
     // The last array passed, will remove variables that are not used in the db table
     wm3Sql::saveAllTableFields('_menu_bars_items',$_FIELD,array('pageID','subchannelID','link_external_url','link_external_target'));

     wm3Sql::sqlQuery("UNLOCK TABLES");
     return wm3Sql::getLastInsertID();
    }

   public static function updateMenuBarItem($w3)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");
     
     $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray(),WM3_cQUOTE_DB);
     
     wm3MenuBar::updateMenuBarItemPositions($_FIELD['menu_bar_itemID'],$_FIELD['position']);

     switch($_FIELD['categoryID'])
      {
       case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:   { $_FIELD['linkID'] = $_FIELD['pageID'];  $_FIELD['url'] = $_FIELD['target'] = ''; break; }
       case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:  { $_FIELD['linkID'] = $_FIELD['subchannelID']; $_FIELD['url'] = $_FIELD['target'] = ''; break; }
	   case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['link_external_url']; $_FIELD['target'] = $_FIELD['link_external_target']; break; }
       default: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['target'] = ''; }
      }

     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                       SET title      = '".$_FIELD['title']."',
                           linkID     = '".$_FIELD['linkID']."',
                           categoryID = '".$_FIELD['categoryID']."',
                           url        = '".$_FIELD['url']."',
                           target     = '".$_FIELD['target']."',
                           position   = '".$_FIELD['position']."',
                           enabled    = '".$_FIELD['enabled']."',
                           languageID = '".$_FIELD['languageID']."'
                       WHERE menu_bar_itemID = '".$_FIELD['menu_bar_itemID']."'");
                       
     wm3Sql::sqlQuery("UNLOCK TABLES");
     return $_FIELD['menu_bar_itemID'];
    }

   public static function swapMenuBarItem($w3)
    {
     // Swap two item position (move up or down items)
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");
     
     $menu_bar_itemID = $w3->getVariable('menu_bar_itemID','get');
     $swapID          = $w3->getVariable('swapID','get');     
     $swap_position   = wm3MenuBar::getPosition($swapID);
     $position        = wm3MenuBar::getPosition($menu_bar_itemID);

     if($position && $swap_position) // Swap effected only if the item exists (by checking the position)
      {
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                         SET position          = '$swap_position'
                         WHERE menu_bar_itemID = '$menu_bar_itemID'");
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                         SET position          = '$position'
                         WHERE menu_bar_itemID = '$swapID'");
      }

     wm3Sql::sqlQuery("UNLOCK TABLES");
     return $menu_bar_itemID;
    }

   public static function updateMenuBarItemPositions($menu_bar_itemID,$new_position)
    {
     // Update the right item position when an item position changed
     $position = wm3MenuBar::getPosition($menu_bar_itemID);

     if($position) // Update effected only if the item exists (by checking the position)
      {
       if($new_position > $position)
        {
         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position = position - 1
                           WHERE position > '$position' AND position <= '$new_position'");

         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position          = '$new_position'
                           WHERE menu_bar_itemID = '$menu_bar_itemID'");
        }
       else
        {
         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position = position + 1
                           WHERE position >= '$new_position' AND position < '$position'");

         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position          = '$new_position'
                           WHERE menu_bar_itemID = '$menu_bar_itemID'");
        }
      }
    }

   public static function disableMenuBarItem($menu_bar_itemID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items SET enabled = '".WM3_cDISABLED."' WHERE menu_bar_itemID = '$menu_bar_itemID'"); }

   public static function enableMenuBarItem($menu_bar_itemID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items SET enabled = '".WM3_cENABLED."'  WHERE menu_bar_itemID = '$menu_bar_itemID'"); }
   
   public static function deleteMenuBarItem($menu_bar_itemID)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");

     $position = wm3MenuBar::getPosition($menu_bar_itemID);
     if($position) // Update positions only if the deleted item exists (by checking the position)
      {
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                         SET position = position - 1
                         WHERE position > '$position'");
      }
   	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WHERE menu_bar_itemID = '$menu_bar_itemID'");

   	 wm3Sql::sqlQuery("UNLOCK TABLES");
   	}

   public static function selectMenuBarItemCategory($w3,$name,$categoryID,$js = '')
    {
     // Make menu item categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                             ORDER BY position DESC");
     $i = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_LABEL[$i] = $w3->getLanguageObj()->translate($row->name);
       $_VALUE[$i] = $row->categoryID;
       $i++;
      } 
     return wm3Util::selectArray($name,$_LABEL,$_VALUE,$categoryID,$js);
    }

   public static function getMenuBarItemCategoryName($categoryID,$w3)
    {
     // Get menu item category name
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories WHERE categoryID = '$categoryID'");
     $row = mysql_fetch_object($rs);
     return $w3->getLanguageObj()->translate($row->name);
    }

   public static function selectMenuBarItemPosition($name,$position,$w3)
    {
     // Make menu item position select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items");
     $str = "<select name=\"$name\">";
     $i = 1;
     while($row = mysql_fetch_object($rs))
      {
       if($position == $i) $str .= wm3Util::inputOption($i,$i,"selected");
       else                $str .= wm3Util::inputOption($i,$i);
       $i++;
      }
     if($w3->getAction() == WM3_cACTION_ADD_MENU_BAR_ITEM ||
        $w3->getAction() == WM3_cACTION_SAVE_MENU_BAR_ITEM)
      {
       if($position == $i) $str .= wm3Util::inputOption($i,$i,"selected");
       else                $str .= wm3Util::inputOption($i,$i);       
      }
     $str .= "</select>";
     return $str;
    }

  }

?>
