<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Page
  {
   private $pageID;
   private $title,$subtitle,$icon,$label,$submenu,$content;
   private $html;
   private $column_empty_left,$column_empty_right;
   private $render_home_content,$render_page_content,$render_news,$render_channels,$render_center_panels;

   function __construct()
    {
     $this->pageID   = 0;
     $this->title    = "";
     $this->subtitle = "";
	 $this->icon     = "";
	 $this->label    = "";
	 $this->submenu  = "";
	 $this->content  = "";
	 $this->render_head_foot    = true;
     $this->column_empty_left   = $this->column_empty_right = false;
     $this->render_home_content = $this->render_page_content = $this->render_news = $this->render_channels = $this->render_center_panels = false;
    }

   public static function getPageFieldsArray()
    {
     return array('pageID','title','subtitle','enabled','categoryID','page_type','visibility','groupID','backID','left_panels_enabled','right_panels_enabled','render_mode','head','body','foot','expansion','backID','hits','languageID','ts');
    }

   public function createHomePage($w3)
    {
     // Get home page content following the action
     switch($w3->getSection())
      {
       case WM3_cSECTION_PAGES:
        {
         // Get a dynamic page from db
         $w3->getPageObj()->setPageID($w3->getVariable('pageID','both'));
         $this->render_page_content = true;
         $this->getHomePage($w3);
         break;
        }
       case WM3_cSECTION_NEWS:
        {
         // Show single news/comments and more (for home page)
		 $this->hidePanelsActionHome($w3);
         $this->render_news = true;
         break;
        }
       case WM3_cSECTION_CHANNELS:
        {
         // Show subchannel blocks (for home page)
		 $this->hidePanelsActionHome($w3);
         $this->render_channels = true;
         break;
        }        
       default: // No section specified
        {
         switch($w3->getAction())
          {
		   case WM3_cACTION_CLICK_BANNER_EXCHANGE:
		    {
			 wm3Banner::clickBannerExchange($w3);
			 $this->renderDefaultHomeContent($w3);
			 break;
		    }
           case WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY:
            {
             // Show ecommerce subcategory (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = ""; // TODO
             $this->subtitle = "&nbsp;"; // TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceSubcategoryList($w3,$w3->getVariable('subcategoryID','both'),false,false,true,true,true,true,false);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_SPECIAL_OFFER:
            {
             // Show ecommerce special offer (for home page)
             $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = ""; // TODO
             $this->subtitle = "&nbsp;"; // TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceProductList($w3,$w3->getVariable('productID','both'),false,true,true,true);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_PRODUCT:
            {
             // Show ecommerce subcategory (for home page)
             $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = ""; // TODO
             $this->subtitle = "&nbsp;"; // TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceProductList($w3,$w3->getVariable('productID','both'));
             break;
            }
           case WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Show ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = ""; // TODO
             $this->subtitle = "&nbsp;"; // TODO
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->html     = wm3Ecommerce::renderEcommerceSingleProduct($w3);
             break;
            }
           case WM3_cACTION_INFORMATIONS_SINGLE_ECOMMERCE_PRODUCT:
            {
             // More informations form for an ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
               $this->render_page_content = true;
               $this->title    = ""; // TODO
               $this->subtitle = "&nbsp;"; // TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,0,true);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SEND_INFORMATIONS_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Send more informations email for an ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
               $this->render_page_content = true;
               $this->title    = "";//TODO
               $this->subtitle = "&nbsp;";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
	    	                                 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
		    	                             ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
               $error = wm3Newsletter::checkContactError($w3);
			   if(!$error)
			     {
                  $allowed = wm3Newsletter::addToNewsletterContact($w3);
		          wm3Sql::sqlQuery("UNLOCK TABLES");
                  $msg = wm3Newsletter::sendContact($w3,$allowed,false);
			      $this->html = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,0,true,false,$msg);
			     }
			   else
			     {
			      wm3Sql::sqlQuery("UNLOCK TABLES");
			      $this->html = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,$error,true);
			     }
			  }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SEND_TO_FRIEND_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Send to friend form for an ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
               $this->render_page_content = true;
               $this->title    = "";//TODO
               $this->subtitle = "&nbsp;";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,0,false,true);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SEND_SEND_TO_FRIEND_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Send to friend for an ecommerce product (for home page)
			 $this->hidePanelsActionHome($w3);
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
               $this->render_page_content = true;
               $this->title    = "";//TODO
               $this->subtitle = "&nbsp;";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
	    	                                 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
		    	                             ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
               $error = wm3Newsletter::checkSendToFriendError($w3);
			   if(!$error)
			     {
                  $allowed = wm3Newsletter::addToNewsletterSendToFriend($w3);
		          wm3Sql::sqlQuery("UNLOCK TABLES");
				  $msg = wm3Newsletter::sendSendToFriend($w3,$allowed,true,true);
			      $this->html = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,0,false,true,$msg);
			     }
			   else
			     {
			      wm3Sql::sqlQuery("UNLOCK TABLES");
			      $this->html = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,$error,false,true);
			     }
			  }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_PRINTABLE_SINGLE_ECOMMERCE_PRODUCT:
            {
             // Show printable version of ecommerce product (for home page)
			 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
			  {
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "";//TODO
               $this->subtitle = "&nbsp;";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
			   wm3Ecommerce::renderEcommerceSingleProductPrintable($w3);
		      }
             break;
            }
           case WM3_cACTION_ADD_ECOMMERCE_CART_ITEM:
            {
             // Add ecommerce item cart and show current users cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
               $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Cart";//TODO
               $this->subtitle = "Item added to cart";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
			   $error = wm3Ecommerce::saveEcommerceCartItem($w3);
			   if(!$error)
                $this->html = wm3Ecommerce::renderEcommerceCart($w3,0,false);
			   else
			    $this->html = wm3Ecommerce::renderEcommerceSingleProduct($w3,0,false,true,$error);
			  }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_DELETE_ECOMMERCE_CART_ITEM:
            {
             // Delete ecommerce item cart and show current users cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Cart";//TODO
               $this->subtitle = "Item removed from cart";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
		       wm3Ecommerce::deleteEcommerceCartItem($w3,$w3->getVariable('cart_itemID','both'));
               $this->html = wm3Ecommerce::renderEcommerceCart($w3,0,false);
			  }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM:
            {
             // Show current user orders list (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
               $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Orders";//TODO
               $this->subtitle = "Order details";
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::getEcommerceOrderItemList($w3,0,false);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_ORDER:
            {
             // Show current user orders list (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Orders"; // TODO
               $this->subtitle = $w3->getWord(794);
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::getEcommerceOrderList($w3,0,false);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SHOW_ECOMMERCE_CART:
            {
			 // Show current user ecommerce cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
               $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Cart";//TODO
               $this->subtitle = $w3->getWord(734).wm3User::getUserLogin($w3->getAuthenticateUserID());
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceCart($w3,0,false);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_PROCESS_ECOMMERCE_ORDER:
            {
             // Process current user ecommerce cart to make an order (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Order";//TODO
               $this->subtitle = "Current order details";//TODO
               $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
               $this->html     = wm3Ecommerce::renderEcommerceCart($w3,0,false,true);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_CONFIRM_ECOMMERCE_ORDER:
            {
             // Confirm and add an order from current user ecommerce cart (for home page)
			 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
              {
               if(!$w3->getAuthenticateUserID()) { header("Location: ".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER); die; } // Redirect to user login panel
			   $this->hidePanelsActionHome($w3);
               $this->render_page_content = true;
               $this->title    = "Order";//TODO
               $this->subtitle = "Complete current order";//TODO
               //$w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
	           $this->html     = wm3Ecommerce::saveEcommerceCartOrder($w3);
		      }
			 else $this->renderDefaultHomeContent($w3);
             break;
            }
           case WM3_cACTION_SEARCH:
            {
             // Search function (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(527);
             $this->subtitle = ""; // Taked from next line
             $this->html     = wm3SearchEngine::renderUserSearchResult($w3);
             break;
            }
           case WM3_cACTION_SEND_TO_FRIEND:
            {
             // Send to friend function (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Send to friend";//TODO
             $this->subtitle = "Send to friend this website";//TODO
             wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
	    	                               ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
		                                   ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
			 $error = wm3Newsletter::checkSendToFriendError($w3);
             if(!$error) {
                          $allowed = wm3Newsletter::addToNewsletterSendToFriend($w3);
		                  wm3Sql::sqlQuery("UNLOCK TABLES");
                          $this->html = wm3Newsletter::sendSendToFriend($w3,$allowed);
                         }
             else        {
			              wm3Sql::sqlQuery("UNLOCK TABLES");
			              $this->html = wm3Newsletter::renderSendToFriendError($w3,$error);
		                 }
             break;
            }
           case WM3_cACTION_NEWSLETTER_JOIN:
            {
             // Subscribe to the newsletter (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(374);
             $this->subtitle = "Join our newsletter";//TODO
             wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE");
             $this->html     = wm3Newsletter::joinNewsletter($w3);
			 wm3Sql::sqlQuery("UNLOCK TABLES");
             break;
            }
           case WM3_cACTION_NEWSLETTER://TODO serve???
            {
             // Add/remove newsletter function (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Email added";//TODO
             $this->subtitle = "added???";//TODO
             $this->html     = "Grazie email??? per esserti iscritto TODO"; //wm3SearchEngine::getSearchEngineItemList($w3); 
             break;
            }
           case WM3_cACTION_CHANGE_LANGUAGE:
            {
             // Switch to another home language and set cookie
             $this->render_home_content  = true;
             $this->render_news          = $w3->getPreferences('show_home_news');
             $this->render_center_panels = true;
             $languageID = wm3Language::writeCookieHomeLanguageID($_POST['languageID']);
             $w3->setHomeLanguage($languageID);
             $w3->getLanguageObj()->getLanguageFile($languageID);
             $w3->setPreferencesContents();
             $this->html = $w3->getPreferencesContents('home');
			 
             break;
            }
           case WM3_cACTION_SURVEY_VOTE:
            {
             // Vote for a survey (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Vatazione sondaggio";//TODO
             $this->subtitle = "Voto registrato correttamente";//TODO
             $this->html     = wm3Survey::voteSurvey($w3);
             break;
            }
           case WM3_cACTION_SURVEY_RESULTS:
            {
             // Vote for a survey (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(887);
             $this->subtitle = $w3->getWord(841);
             $this->html     = wm3Survey::renderSurveyResult($w3);
             break;
            }
           case WM3_cACTION_CONSULT_HOROSCOPE:
            {
             // Consult horoscope (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = $w3->getWord(1752);
             $this->subtitle = "Daily horoscope";//TODO
             $this->html     = wm3Horoscope::renderHoroscopeConsult($w3);
             break;
            }
           case WM3_cACTION_RETRIEVE_PASSWORD:
            {
             // Retrieve a password from email (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "Retrieve password";//TODO
             $this->subtitle = "Retrieve password from email";//TODO
             $this->html     = wm3User::renderRetrievePassword($w3);
             break;
            }
           case WM3_cACTION_SHOW_USER_INFORMATIONS:
            {
             // Show informations about an user (for home page)
			 $this->hidePanelsActionHome($w3);
             $this->render_page_content = true;
             $this->title    = "User informations";//TODO
             $this->subtitle = "User informations";//TODO
			 if(!$w3->getAuthenticateAdminUserID()) $this->html = "<div align=\"center\"><img src=\"".WM3_cPATH_DATA."misc_stop.png\" width=\"48\" height=\"48\" border=\"0\"><br><br>".$w3->getWord(554)."</div>";
			 else                                   $this->html = wm3User::getSingleUserInformation($w3,0,$w3->getVariable('userID','get'),false);
             break;
            }
           default: // No section and no action specified
            {
			 $this->renderDefaultHomeContent($w3);
            }
          }
        }
      }
    }

   public function renderDefaultHomeContent($w3)
    {
	 // Get home page content from db and render it
     $this->render_home_content  = true;
     $this->render_news          = $w3->getPreferences('show_home_news');
     $this->render_center_panels = true;
     $this->html = $w3->getPreferencesContents('home');		
	}

   public function createUserPage($w3)
    {
     // Get user page content
	 $this->render_home_content  = false;
     $this->render_page_content  = true;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     if($w3->getAuthenticateUserID()) // User can access
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
       $this->title    = $w3->getSkinObj()->getLeftPageTitle()."Webmatic ".WM3_cVERSION." (User control panel)".$w3->getSkinObj()->getRightPageTitle();
	   $this->subtitle = wm3Util::renderDate($w3,time(),$w3->getHomeLanguage(),true,'',false,true)." ".$w3->getWord(1528)." ".wm3User::getUserLogin($w3->getAuthenticateUserID())." $_SEP <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">home</a> $_SEP <a href=\"".WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&action=".WM3_cACTION_LOGOUT."\">logout</a>";
       switch($w3->getSection())
        {
         case WM3_cSECTION_USER_MESSAGES:
          {
           if(wm3User::checkUserPermission($w3,3)) // User messages
            {
             $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(600);
             $this->icon    = wm3Util::renderImg("big_icon_users_messages.png",'',48,48);
             $this->submenu = "user_user_message_submenu.inc";
             $this->content = wm3UserMessage::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_NEWS:
          {
           if(wm3User::checkUserPermission($w3,1)) // News
            {
             $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(511);
             $this->icon    = wm3Util::renderImg("big_icon_news.png",'',48,48);
             $this->submenu = "user_news_submenu.inc";
             $this->content = wm3News::executeUserAction($w3,wm3User::checkUserPermission($w3,2));
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_FORUMS:
          {
           if(wm3User::checkUserPermission($w3,4)) // Forums
            {
             $w3->getSectionObj()->setParameters(wm3Forum::getSectionParameters());
             $this->label   = $w3->getWord(1375);
             $this->icon    = wm3Util::renderImg("big_icon_forum.png",'',48,48);
             $this->submenu = "user_forum_submenu.inc";
             $this->content = wm3Forum::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_BANNERS:
          {
           if(wm3User::checkUserPermission($w3,5)) // Banners
            {
             //$w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(510);
             $this->icon    = wm3Util::renderImg("big_icon_banners.png",'',48,48);
             $this->submenu = "user_banner_submenu.inc";
             $this->content = wm3Banner::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MARKET:
          {
           if(wm3User::checkUserPermission($w3,6)) // Little market
            {
             $w3->getSectionObj()->setParameters(wm3Market::getSectionParameters());
             $this->label   = $w3->getWord(509);
             $this->icon    = wm3Util::renderImg("big_icon_market.png",'',48,48);
             $this->submenu = "user_market_submenu.inc";
             $this->content = wm3Market::executeUserAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_USER_INFORMATIONS:
          {
           $this->label   = $w3->getWord(398);
           $this->icon    = wm3Util::renderImg("quick_info_user.png",'',48,48);
           $this->submenu = "admin_user_information_submenu.inc";
           $this->content = wm3User::executeUserInformationUserAction($w3);
		   break;
          }
         default:
          {
           if($w3->getSection() >= WM3_cEXPANSION_SECTION_MIN) // Its an expansion ID
            {
             $_expansion = new wm3Expansion($w3,'',0,WM3_cEXPANSION_TYPE_USER,$w3->getSection());

             if(!$_expansion->getError() && $_expansion->checkPermission($w3,WM3_cEXPANSION_TYPE_USER))
              {
               // ID found and no errors, execute the expansion
               $this->label   = $_expansion->getLabel($w3).$_expansion->getHelpButton($w3);
               $this->icon    = wm3Util::renderImg($_expansion->getBigIcon(),'',48,48,$path = $_expansion->getPath());
               $this->submenu = $_expansion->getSubMenu();
               $this->content = $_expansion->exec($w3);
               break;
		      }
			}
           // No expansion ID found or expansion error (render admin homepage)
           $this->label   = $w3->getWord(501);
           $this->icon    = wm3Util::renderImg("big_icon_home_user.png",'',48,48);
           $this->submenu = "";
           $this->content = wm3Page::getUserHomepage($w3);
          }          
        }
      }
     else
      {
       switch($w3->getAction())
        {
         case WM3_cACTION_LOGIN: { $this->getUserLoginPage($w3,1); break; }
         default:                { $this->getUserLoginPage($w3); }
        } 
      }
    }

   public function createAdminPage($w3)
    {
     // Get admin page content
	 $this->render_home_content  = false;
     $this->render_page_content  = true;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     if($w3->getAuthenticateAdminID()) // Administrator can access
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
       $this->title    = $w3->getSkinObj()->getLeftPageTitle()."Webmatic ".WM3_cVERSION." (Admin control panel)".$w3->getSkinObj()->getRightPageTitle();
       $this->subtitle = wm3Util::renderDate($w3,time(),$w3->getAdminLanguage(),true,'',false,true)." ".$w3->getWord(1528)." ".wm3User::getUserLogin($w3->getAuthenticateAdminID())." $_SEP <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">home</a> $_SEP <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&action=".WM3_cACTION_LOGOUT."\">logout</a>";
       switch($w3->getSection())
        {
         case WM3_cSECTION_USER_MESSAGES:
          {
		   // No permission needed here
           $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
           $this->label   = $w3->getWord(600);
           $this->icon    = wm3Util::renderImg("big_icon_users_messages.png",'',48,48);
           $this->submenu = "admin_user_message_submenu.inc";
           $this->content = wm3UserMessage::executeAdminAction($w3);
		   break;
          }
         case WM3_cSECTION_FAQ:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ))
            {
             $w3->getSectionObj()->setParameters(wm3Faq::getSectionParameters());
             $this->label   = $w3->getWord(506)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(3),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_faq.png",'',48,48);
             $this->submenu = "admin_faq_submenu.inc";
             $this->content = wm3Faq::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_SEARCH_ENGINE:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE))
            {
             $this->label   = $w3->getWord(507)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(4),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_searchengine.png",'',48,48);
             $this->submenu = "admin_search_engine_submenu.inc";
             $this->content = wm3SearchEngine::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MARKET:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MARKET))
            {
             $w3->getSectionObj()->setParameters(wm3Market::getSectionParameters());            	
             $this->label   = $w3->getWord(509)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(6),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_market.png",'',48,48);
             $this->submenu = "admin_market_submenu.inc";
             $this->content = wm3Market::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_BANNERS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_BANNERS))
            {
             $this->label   = $w3->getWord(510);
             $this->icon    = wm3Util::renderImg("big_icon_banners.png",'',48,48);
             $this->submenu = "admin_banner_submenu.inc";
             $this->content = wm3Banner::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_NEWS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS))
            {
             $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
             $this->label   = $w3->getWord(511)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(8),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_news.png",'',48,48);
             $this->submenu = "admin_news_submenu.inc";
             $this->content = wm3News::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_LINKS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_LINKS))
            {
             $w3->getSectionObj()->setParameters(wm3Link::getSectionParameters());
             $this->label   = $w3->getWord(512)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(9),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_links.png",'',48,48);
             $this->submenu = "admin_link_submenu.inc";
             $this->content = wm3Link::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }          
         case WM3_cSECTION_NEWSLETTER:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWSLETTER))
            {
             $this->label   = $w3->getWord(508)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(5),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_banners.png",'',48,48);
             $this->submenu = "admin_newsletter_submenu.inc";
             $this->content = wm3Newsletter::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_HOROSCOPE:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_HOROSCOPE))
            {
             $this->label   = $w3->getWord(514)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(11),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_horoscope.png",'',48,48);
             $this->submenu = "admin_horoscope_submenu.inc";
             $this->content = wm3Horoscope::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MESSAGES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MESSAGES))
            {
             $this->label   = $w3->getWord(515);
             $this->icon    = wm3Util::renderImg("big_icon_messages.png",'',48,48);
             $this->submenu = "admin_message_submenu.inc";
             $this->content = wm3Message::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MENU_BARS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MENU_BARS))
            {
			 $w3->getSectionObj()->setParameters(wm3Channel::getSectionParameters());
             $this->label   = $w3->getWord(519);
             $this->icon    = wm3Util::renderImg("big_icon_menubar.png",'',48,48);
             $this->submenu = "admin_menu_bar_submenu.inc";
             $this->content = wm3MenuBar::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_PANELS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PANELS))
            {
             $this->label   = $w3->getWord(516);
             $this->icon    = wm3Util::renderImg("big_icon_panels.png",'',48,48);
             $this->submenu = "admin_panel_submenu.inc";
             $this->content = wm3Panel::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_CHANNELS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_CHANNELS))
            {
             $w3->getSectionObj()->setParameters(wm3Channel::getSectionParameters());
             $this->label   = $w3->getWord(517)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(14),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_channels.png",'',48,48);
             $this->submenu = "admin_channel_submenu.inc";
             $this->content = wm3Channel::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_USERS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS))
            {
             $this->label   = $w3->getWord(513);
             $this->icon    = wm3Util::renderImg("big_icon_users.png",'',48,48);
             $this->submenu = "admin_user_submenu.inc";
             $this->content = wm3User::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_PAGES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
            {
             $this->label   = $w3->getWord(518)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(15),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_pages.png",'',48,48);
             $this->submenu = "admin_page_submenu.inc";
             $this->content = wm3Page::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_ECOMMERCE:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE))
            {
             $w3->getSectionObj()->setParameters(wm3Ecommerce::getSectionParameters());
             $this->label   = $w3->getWord(656);
             $this->icon    = wm3Util::renderImg("big_icon_ecommerce.png",'',48,48);
             $this->submenu = "admin_ecommerce_submenu.inc";
             $this->content = wm3Ecommerce::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_SURVEYS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_SURVEYS))
            {
             $this->label   = $w3->getWord(835);
             $this->icon    = wm3Util::renderImg("big_icon_surveys.png",'',48,48);
             $this->submenu = "admin_survey_submenu.inc";
             $this->content = wm3Survey::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_FORUMS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS))
            {
             $w3->getSectionObj()->setParameters(wm3Forum::getSectionParameters());
             $this->label   = $w3->getWord(973);
             $this->icon    = wm3Util::renderImg("big_icon_forum.png",'',48,48);
             $this->submenu = "admin_forum_submenu.inc";
             $this->content = wm3Forum::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_DOWNLOADS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS))
            {
             $w3->getSectionObj()->setParameters(wm3Download::getSectionParameters());
             $this->label   = $w3->getWord(1036);
             $this->icon    = wm3Util::renderImg("big_icon_downloads.png",'',48,48);
             $this->submenu = "admin_download_submenu.inc";
             $this->content = wm3Download::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_DIRECTORIES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_DIRECTORIES))
            {
             //$w3->getSectionObj()->setParameters(wm3Directory::getSectionParameters());
             $this->label   = $w3->getWord(1037);
             $this->icon    = wm3Util::renderImg("big_icon_directories.png",'',48,48);
             $this->submenu = "admin_directory_submenu.inc";
             $this->content = wm3Directory::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_MEDIA_ALBUMS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS))
            {
             $w3->getSectionObj()->setParameters(wm3MediaAlbum::getSectionParameters());
             $this->label   = $w3->getWord(1335);
             $this->icon    = wm3Util::renderImg("big_icon_albums.png",'',48,48);
             $this->submenu = "admin_media_album_submenu.inc";
             $this->content = wm3MediaAlbum::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_PREFERENCES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PREFERENCES))
            {
             $this->label   = $w3->getWord(27);
             $this->icon    = wm3Util::renderImg("big_icon_preferences.png",'',48,48);
             $this->submenu = "admin_preferences_submenu.inc";
             $this->content = wm3Preferences::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_METATAGS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_METATAGS))
            {
             $this->label   = $w3->getWord(1373);
             $this->icon    = wm3Util::renderImg("big_icon_metatags.png",'',48,48);
             $this->submenu = "admin_metatag_submenu.inc";
             $this->content = wm3Metatag::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_FOLDERS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FOLDERS))
            {
             $this->label   = $w3->getWord(1374);
             $this->icon    = wm3Util::renderImg("big_icon_folders.png",'',48,48);
             $this->submenu = "admin_folder_submenu.inc";
             $this->content = wm3Folder::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_WEBMAIL:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_WEBMAIL))
            {
             $this->label   = $w3->getWord(1454);
             $this->icon    = wm3Util::renderImg("big_icon_webmail.png",'',48,48);
             $this->submenu = "admin_webmail_submenu.inc";
             $this->content = wm3Webmail::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_LANGUAGES:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_LANGUAGES))
            {
             $this->label   = $w3->getWord(1291);
             $this->icon    = wm3Util::renderImg("big_icon_languages.png",'',48,48);
             $this->submenu = "admin_language_submenu.inc";
             $this->content = wm3Language::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }
         case WM3_cSECTION_STATISTICS:
          {
           if(wm3User::checkAdminPermission($w3,WM3_cSECTION_STATISTICS))
            {
             $this->label   = $w3->getWord(54);
             $this->icon    = wm3Util::renderImg("big_icon_statistics.png",'',48,48);
             $this->submenu = "admin_statistic_submenu.inc";
             $this->content = wm3Statistic::executeAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }

         case WM3_cSECTION_DATABASE: // Only superuser can manage database
          {
           if(wm3User::isSuperUser($w3->getAuthenticateAdminID()) &&
              WM3_cCONFIG_USE_SUPERUSER_DATABASE_MANAGEMENT)
            {
             $this->label   = $w3->getWord(1281)." ".wm3Util::helpButton('misc_help.png',$w3->getWordHelp(26),$w3->getWord(65));
             $this->icon    = wm3Util::renderImg("big_icon_database.png",'',48,48);
             $this->submenu = "admin_database_submenu.inc";
             $this->content = wm3Sql::executeAdminAction($w3);
            }
           else $this->accessDeniedSection($w3);
           break;
          }

         case WM3_cSECTION_USER_INFORMATIONS:
          {
           $this->label   = $w3->getWord(398);
           $this->icon    = wm3Util::renderImg("quick_info_user.png",'',48,48);
           $this->submenu = "admin_user_information_submenu.inc";
           $this->content = wm3User::executeUserInformationAdminAction($w3);
		   break;
          }
         case WM3_cSECTION_WEBMATIC_INFORMATIONS:
          {
           $this->label   = "Webmatic informations";//$w3->getWord(398);
           $this->icon    = wm3Util::renderImg("big_icon_info.png",'',48,48);
           $this->submenu = "admin_webmatic_information_submenu.inc";   
           $this->content = wm3Statistic::executeWebmaticInformationAdminAction($w3);
		   break;
          }
         default:
          {
           if($w3->getSection() >= WM3_cEXPANSION_SECTION_MIN) // Its an expansion ID
            {
             $_expansion = new wm3Expansion($w3,'',0,WM3_cEXPANSION_TYPE_ADMIN,$w3->getSection(),true);

             if(!$_expansion->getError() && $_expansion->checkPermission($w3,WM3_cEXPANSION_TYPE_ADMIN))
              {
               // ID found and no errors, execute the expansion
               $this->label   = $_expansion->getLabel($w3).$_expansion->getHelpButton($w3);
               $this->icon    = wm3Util::renderImg($_expansion->getBigIcon(),'',48,48,$path = $_expansion->getPath());
               $this->submenu = $_expansion->getSubMenu();
               $this->content = $_expansion->exec($w3);
               break;
		      }
			}
           // No expansion ID found or expansion error (render admin homepage)
           $this->label   = $w3->getWord(501);
           $this->icon    = wm3Util::renderImg("big_icon_home_admin.png",'',48,48);
           $this->submenu = '';
           $this->content = wm3Page::getAdminHomepage($w3);
          }
        }
      }
     else
      {
       switch($w3->getAction())
        {
         case WM3_cACTION_LOGIN: { $this->getAdminLoginPage($w3,1); break; }
         default:                { $this->getAdminLoginPage($w3); }
        } 
      }
    }

   public function createChatPage($w3)
    {
     // Get chat page content following the action
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     wm3Chatroom::deleteChatroomExpiredSentences($w3);
     switch($w3->getAction())
      {
       case WM3_cACTION_JOIN_CHATROOM:
        {
         // Join an user in a chatroom
	     $this->html =  wm3Chatroom::joinChatroom($w3);
		 if(wm3Chatroom::isChatroomAllowed($w3))
		  $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_SENTENCE."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
         break;
        }
       case WM3_cACTION_SHOW_CHATROOM_USER:
        {
         // Show chatroom current users
		 if(wm3Chatroom::isChatroomAllowed($w3) && wm3Session::chatroomSessionExists($w3))
		  {
           $this->html =  wm3Chatroom::renderChatroomUserList($w3);
		   $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_USER."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
	      }
		 else $this->html = "";
         break;
        }
       case WM3_cACTION_SEND_CHATROOM_SENTENCE:
        {
         // Send a sentence in a chatroom
		 if(wm3Chatroom::isChatroomAllowed($w3) && wm3Session::chatroomSessionExists($w3))
		  {
	       $this->html =  wm3Chatroom::renderChatroomSentenceList($w3,wm3Chatroom::saveChatroomSentence($w3));
		   $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_SENTENCE."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
	      }
		 else $this->html = "";
         break;
        }
       case WM3_cACTION_SHOW_CHATROOM_SENTENCE:
        {
         // Get chatroom sentences and render it
    	 if(wm3Chatroom::isChatroomAllowed($w3) && wm3Session::chatroomSessionExists($w3))
		  {
		   wm3Session::chatroomSessionUpdate($w3);
           $this->html =  wm3Chatroom::renderChatroomSentenceList($w3);
		   $this->html .= wm3Util::metaRefresh(5,WM3_cCONFIG_CHAT_FILE."?stage=".WM3_cSTAGE_CHAT."&action=".WM3_cACTION_SHOW_CHATROOM_SENTENCE."&chatroomID=".$w3->getVariable('chatroomID','get')."&nickname=".$w3->getVariable('nickname','get'));
	      }
	     else $this->html = "";
         break;
        }
       default: // No action specified
        {
         // Do nothing
         $this->html = "";
        }
      }
    }

   public function createRssPage($w3)
    {
     // Get rss page content following the action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
	 $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_RSS_CATEGORY:
        {
         // Get news rss by category (for a certain language)
		 $this->html = wm3News::renderRssNews($w3);
         require(WM3_cPATH_INCLUDE."home_rss.inc");
         break;
        }
       case WM3_cACTION_SHOW_RSS_AUTHOR:
        {
         // Get news rss by author (for a certain language)
		 $this->html = wm3News::renderRssNews($w3);
		 require(WM3_cPATH_INCLUDE."home_rss.inc");
         break;
        }
       default: // No action specified
        {
		 // Get all news rss (for a certain language)
		 $this->html = wm3News::renderRssNews($w3);
		 require(WM3_cPATH_INCLUDE."home_rss.inc");
        }
      }
    }

   public function createBannerExchangePage($w3)
    {
     // Get banner exchange page content following the action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
	 $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());// Questo qui serve???
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     switch($w3->getAction())
      {
       default: // No action specified
        {
		 // Get a random banner (for a certain language)
		 $this->html = wm3Banner::renderBannerExchange($w3,true,true);
		 require(WM3_cPATH_INCLUDE."home_banner_exchange.inc");
        }
      }
    }

   public function createCaptchaPage($w3)
    {
     // Captcha page content following the action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
     $this->render_home_content  = true;
     $this->render_page_content  = false;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
     switch($w3->getAction())
      {
       default: // No action specified
        {
		 // Output a captcha image
		 $this->html = wm3Captcha::makeCaptcha();
		 require(WM3_cPATH_INCLUDE."home_captcha.inc");
        }
      }
    }

   public function createKernelPage($w3)
    {
     // Execute a kernel action
     //TODO evitare aumento contatori quando si richiamano gli RSS? (evitare anche logs???)
     $this->render_home_content  = false;
     $this->render_page_content  = true;
     $this->render_news          = false;
     $this->render_channels      = false;
     $this->render_center_panels = false;
	 $this->html = wm3Kernel::execute($w3,$w3->getAction());
	 require(WM3_cPATH_INCLUDE."home_kernel.inc");
    }

   public function renderHomePage($w3)
    {
     // Render home page content with $w3->_skin
     if(wm3Section::isActionPrintable($w3)) // Render a printable content for home page
      {
       $title    = $this->title;
       $content  = $this->html;
       $subtitle = $this->subtitle;
      }
	 else
	  {
       $title    = $this->title; if($title) $title = $w3->getSkinObj()->getLeftPageTitle().$title.$w3->getSkinObj()->getRightPageTitle();
       $subtitle = $this->subtitle;
       $content  = $this->html;
	  }
     if($this->render_home_content)
	  {
	   if($w3->getStage() == WM3_cSTAGE_HOME) { if($w3->getPreferencesContents('home')) require($w3->getSkinObj()->getHome()); }
	   else                                   { require($w3->getSkinObj()->getHome()); }
      }
     if($this->render_page_content)  require($w3->getSkinObj()->getPage($w3));
     if($this->render_center_panels) $w3->getPanelObj()->renderPanels($w3,WM3_cPANEL_CENTER);
     if($this->render_news)
      {
       $w3->getSkinObj()->setCurrentSkinRender(WM3_cSKIN_RENDER_NEWS); // Set current skin render to news render
       $w3->getSectionObj()->setParameters(wm3News::getSectionParameters());
       wm3News::executeHomeAction($w3);
      }
     if($this->render_channels)
      {
       $w3->getSectionObj()->setParameters(wm3Channel::getSectionParameters());
       wm3Channel::renderChannelBlocks($w3);
      }
    }

   public function renderUserPage($w3)
    {
     // Render user page content with $w3->_skin
	 // TODO Se serve fare if per action printable (contenuto printabile per sezione utenti, vedi renderAdminPage qui sotto)
     $title    = $this->title;
     $subtitle = $this->subtitle;
	 $icon     = $this->icon;
     $label    = $this->label;
     $submenu  = $this->submenu;
     $content  = $this->content;
     require($w3->getSkinObj()->getUserPage($w3));
    }

   public function renderAdminPage($w3)
    {
     // Render admin page content with $w3->_skin
	 if(wm3Section::isActionPrintable($w3))
	  {
       $title    = $this->title;
	   $content  = $this->content;
	   $subtitle = $this->subtitle;
	   require($w3->getSkinObj()->getAdminPage($w3));
      }
	 else
	  {
       $title    = $this->title;
       $subtitle = $this->subtitle;
       $icon     = $this->icon;
       $label    = $this->label;
       $submenu  = $this->submenu;
       $content  = $this->content;
       require($w3->getSkinObj()->getAdminPage($w3));
      }
    }

   public static function renderPageExpansion($w3,$pageID)
    {
     $rs = wm3Sql::sqlQuery("SELECT expansion FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                             WHERE pageID = '$pageID' AND categoryID = '".WM3_cPAGE_CATEGORY_EXPANSION."'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);

     $index  = strtok($row->expansion,"_"); // Page index 
     $folder = substr($row->expansion,strlen($index) + 1);
     $_expansion = new wm3Expansion($w3,$folder,$index,WM3_cEXPANSION_TYPE_PAGE);
     return $_expansion->exec($w3);
	}

   public function getHomePage($w3)
    {
     // Get page from db or make an error/denied access

     $error = wm3Page::checkPageAccessError($w3,$this->pageID);
     if(!$error) // Page exist and access granted
      {
	   wm3Page::hitPage($w3);
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                               WHERE pageID = '$this->pageID'");
       $row = mysql_fetch_object($rs);

       // Fast edit page button for admin
       if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES)) { $edit_button = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PAGES."&action=".WM3_cACTION_EDIT_PAGE."&pageID=".$w3->getVariable('pageID','both'),"action_edit.png",$w3->getWord(178))." "; $hits = "<b> ($row->hits)</b>"; }
       else                                                      { $edit_button = ""; $hits = ""; }
       switch($row->categoryID)
        {
         case WM3_cPAGE_CATEGORY_MARKET:
          {
           $w3->getSectionObj()->setParameters(wm3Market::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Market::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_FAQ:
          {
           $w3->getSectionObj()->setParameters(wm3Faq::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Faq::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_SEARCH_ENGINE:
          {
           //$w3->getSectionObj()->setParameters(wm3SearchEngine::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3SearchEngine::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_USER_REGISTRATION:
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3User::executeHomeAction($w3);
           break;
          }          
         case WM3_cPAGE_CATEGORY_LINKS:
          {
           $w3->getSectionObj()->setParameters(wm3Link::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Link::executeHomeAction($w3,$this->pageID); //TODO
           break;
          }
         case WM3_cPAGE_CATEGORY_STATISTICS:
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Statistic::getStatisticBase($w3);
           break;
          }
         case WM3_cPAGE_CATEGORY_USER_INFORMATIONS:
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3User::getPageUserInfo($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_FORUMS:
          {
           $w3->getSectionObj()->setParameters(wm3Forum::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Forum::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_DOWNLOADS:
          {
           $w3->getSectionObj()->setParameters(wm3Download::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Download::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_GUESTBOOKS:
          {
           //$w3->getSectionObj()->setParameters(wm3Guestbook::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Guestbook::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_DIRECTORIES:
          {
           //$w3->getSectionObj()->setParameters(wm3Directory::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Directory::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_MEDIA_ALBUMS:
          {
           $w3->getSectionObj()->setParameters(wm3MediaAlbum::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3MediaAlbum::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_CONTACT:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Newsletter::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_CHAT:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Chatroom::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_WEBMAIL:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Webmail::executeHomeAction($w3,$this->pageID);
           break;
          }
         case WM3_cPAGE_CATEGORY_EXPANSION:
          {
           //$w3->getSectionObj()->setParameters(wm3Newsletter::getSectionParameters());
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle = $row->subtitle; //lasciarlo?
           $this->html     = wm3Page::renderPageExpansion($w3,$this->pageID);
           break;
          }
         default: // WM3_cPAGE_CATEGORY_CUSTOM
          {
           $this->title    = $edit_button.$row->title.$hits;
           $this->subtitle =  $row->subtitle;
           $this->html     = wm3Util::renderContent($w3,$row->body,$row->render_mode);
          }
        }
       if($this->render_head_foot)
	    {
	     $this->html = wm3Util::renderContent($w3,$row->head,$row->render_mode).
	                   $this->html.
                       wm3Util::renderContent($w3,$row->foot,$row->render_mode);
        }

       // Render pages sequence links
       $this->html .= wm3Page::makePagesSequence($w3,$row->pageID);

       // Disable left or right columns if are off for the page
       if($row->left_panels_enabled == WM3_cDISABLED) // Left panels off
        {
         $this->column_empty_left = true;
         $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_LEFT,true);
        }
       if($row->right_panels_enabled == WM3_cDISABLED) // Right panels off
        {
         $this->column_empty_right = true;
         $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_RIGHT,true);
        }
      }
     else
      {
       // Page not exist or access denied
	   if($error == 1) // Page do not exists
	    {
		 $this->title = $this->subtitle = $w3->getWord(555);
		 $this->html = "<div align=\"center\"><img src=\"".WM3_cPATH_DATA."misc_error.png\" width=\"48\" height=\"48\" border=\"0\"><br><br><b>".$w3->getWord(553)."</b></div>";
		}
	   else // Page disabled or access denied
	    {
         $this->title = $this->subtitle = $w3->getWord(556);
         $this->html = "<div align=\"center\"><img src=\"".WM3_cPATH_DATA."misc_stop.png\" width=\"48\" height=\"48\" border=\"0\"><br><br><b>".$w3->getWord(554)."</b></div>";
         $this->html .= wm3Page::makePagesSequence($w3,$this->pageID);
		}
       $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_LEFT, true);
       $this->column_empty_left  = true;
       $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_RIGHT,true);       
       $this->column_empty_right = true;
      }
    }

   public function accessDeniedSection($w3)
    {
     $this->label   = "Access denied"; // TODO $w3->getWord(1010);
     $this->icon    = wm3Util::renderImg("misc_stop.png",'',48,48);
     $this->submenu = "admin_denied_submenu.inc";
     $this->content = "You do not have permission to enter in this section"; // TODO $w3->getWord(1010);
    }

   public function getUserLoginPage($w3,$error = 0)
    {
     // Make login page title and content
     $this->title    = "User login";
     $this->subtitle = "Insert login and password <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">&lt;&lt;&lt;</a>";

     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(array('user_login','user_password'));
	 if(!$error)
	  {
	   $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
	   $form_title = "&nbsp;";
      }
	 else
	  {
	   $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
	   $form_title = $w3->getWord(289);
      }
	 $login_redirect = "";//TODO
     require(WM3_cPATH_INCLUDE."user_login.inc"); // Login form
    }

   public function getAdminLoginPage($w3,$error = 0)
    {
     // Make login page title and content
     $this->title    = "Administrator login";
     $this->subtitle = "Insert login and password <a href=\"".WM3_cCONFIG_ADMIN_FILE."\">&lt;&lt;&lt;</a>";

     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(array('admin_login','admin_password'));
	 if(!$error)
	  {
	   $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
	   $form_title = "&nbsp;";
      }
	 else
	  {
	   $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
	   $form_title = $w3->getWord(289);
      }
	 $login_redirect = ""; //TODO
     require(WM3_cPATH_INCLUDE."admin_login.inc"); // Login form
    }

   public static function makePageLink($pageID,$title,$link_only = false)
    {
     // Make link for menubar or for page list
	 if($link_only) return WM3_cCONFIG_ADMIN_FILE."?section=".WM3_cSECTION_PAGES."&pageID=$pageID";
     return "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?section=".WM3_cSECTION_PAGES."&pageID=$pageID\">$title</a>";
    }

   public static function makePagesSequence($w3,$pageID)
    {
     // Make pages sequence links for a page
     $icon_prev  = "<img src=\"".WM3_cPATH_DATA."misc_prev.png\"  width=\"14\" height=\"14\" align=\"absmiddle\" border=\"0\">";
     $icon_next  = "<img src=\"".WM3_cPATH_DATA."misc_next.png\"  width=\"14\" height=\"14\" align=\"absmiddle\" border=\"0\">";

     // Previous link
     $rs = wm3Sql::sqlQuery("SELECT backID FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'");
     $row = mysql_fetch_object($rs); if(isset($row->backID)) $backID = $row->backID; else $backID = 0;
     $prev = "";
     if($backID)
      {
       $rs = wm3Sql::sqlQuery("SELECT title FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$backID'");
       if(mysql_num_rows($rs) == 1)
        {
	     $row = mysql_fetch_object($rs);
         $prev .= "<nobr><a href=\"".wm3Page::makePageLink($backID,'',true)."\">$icon_prev $row->title</a></nobr>";
	    }
      }

     // Next links
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE backID = '$pageID' ORDER BY pageID");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $columns = 3; $p = 0; $_WIDTHS = array(1,98,1);
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Check if there are any next links
     if($total_items == 0)
      {
	   if($prev) $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,array($prev,'',''),false);
	   else      return '';
	  }

     // Create list items     
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array();
       $next = "<nobr><a href=\"".wm3Page::makePageLink($row->pageID,'',true)."\">$row->title $icon_next</a></nobr>";
       if($p == 0) array_push($_CONTENTS,$prev,'',$next);
       else        array_push($_CONTENTS,'','',$next);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,'');
     return $str;
    }

   public static function getUserHomepage($w3)
    {
     // Render user home page
     $welcome        = "Welcome ".wm3User::getUserLogin($w3->getAuthenticateUserID());//.", you are administrator";
     $previous_login = "Previous login: ".wm3Util::renderDate($w3,wm3User::getUserLastLoginTimeStamp($w3->getAuthenticateUserID(),true),$w3->getHomeLanguage(),false,"Never logged");

     // Prepare variables and quick links array
     $n = 0; // Quick links total number

     $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_USER_INFORMATIONS,"quick_info_user.png","","",$w3->getWord(398),0,48,48);
     if(wm3User::checkUserPermission($w3,1))//TODO costanti WM3_cSECTION_NEWS...
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_NEWS."&action=".WM3_cACTION_ADD_NEWS,"quick_add_news.png","","",$w3->getWord(347),0,48,48);

     $columns = 4;
     $rows = (int)($n / $columns) + 1;

     // Create list header
     $_CONTENTS = array(); $_WIDTHS = array(25,25,25,25); // 4 columns
	 $_SEP = $w3->getSkinObj()->getSeparator();
     array_push($_CONTENTS,"$welcome $_SEP $previous_login");
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create list caption // TODO "Quick link menu" label
     $str .= wm3Section::makeCaptionList($w3,$_WIDTHS,array(194,-1,-1,-1),0);

     // User home bar
	 $_CONTENTS = array();
     $user_messages_label = wm3UserMessage::makeNotReadUserMessage($w3,889,$w3->getAuthenticateUserID());
     $user_messages = wm3Util::actionButton(WM3_cCONFIG_USER_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_USER_MESSAGES,"misc_message.png","","",$user_messages_label,0,15,10);
     array_push($_CONTENTS,$user_messages."<br><br>");
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(4));

	 // Render quick links
     for($i = 0; $i < $rows; $i++)
      {
	   $_CONTENTS = array();
       for($j = 0; $j < $columns; $j++)
        {
		 $p = $j + $i * $columns;
         if($p < $n) array_push($_CONTENTS,$_QUICK_MENU[$p]);
         else        array_push($_CONTENTS,"");
        }
	   $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false);
      }

     // Create bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     //require(WM3_cPATH_INCLUDE."admin_page_form.inc");
     return $str;
    }

   public static function getAdminHomepage($w3)
    {
     // Render admin home page
     switch($w3->getAction())
      {
       case WM3_cACTION_CHANGE_LANGUAGE:
        {
         // Switch to another admin language and set cookie
         $languageID =  wm3Language::writeCookieAdminLanguageID($_POST['languageID']);
         $w3->setAdminLanguage($languageID);
         $w3->getLanguageObj()->getLanguageFile($languageID);
         break;
        }
      }

     $welcome        = "Welcome ".wm3User::getUserLogin($w3->getAuthenticateAdminID()).", you are administrator";
     $previous_login = "Previous login: ".wm3Util::renderDate($w3,wm3User::getAdminLastLoginTimeStamp($w3->getAuthenticateAdminID(),true),$w3->getAdminLanguage(),false,"Never logged");

     // Prepare variables and quick links array
     $n = 0; // Quick links total number

     $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USER_INFORMATIONS,"quick_info_user.png","","",$w3->getWord(398),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PREFERENCES))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PREFERENCES,"big_icon_preferences.png","","",$w3->getWord(27),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_METATAGS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_METATAGS,"big_icon_metatags.png","","",$w3->getWord(1373),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_STATISTICS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_STATISTICS,"big_icon_statistics.png","","",$w3->getWord(54),0,48,48);

	 // Only superuser can manage database
     if(wm3User::isSuperUser($w3->getAuthenticateAdminID()) &&
        WM3_cCONFIG_USE_SUPERUSER_DATABASE_MANAGEMENT)
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DATABASE,"big_icon_database.png","","",$w3->getWord(1281),0,48,48);

     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS."&action=".WM3_cACTION_ADD_USER,"quick_add_user.png","","",$w3->getWord(349),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS."&action=".WM3_cACTION_ADD_NEWS,"quick_add_news.png","","",$w3->getWord(347),0,48,48);
     if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
	  $_QUICK_MENU[$n++] = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PAGES."&action=".WM3_cACTION_ADD_PAGE,"quick_add_page.png","","",$w3->getWord(354),0,48,48);

     $columns = 4;
     $rows = (int)($n / $columns) + 1;

     // Create list header
     $_CONTENTS = array(); $_WIDTHS = array(25,25,25,25); // 4 columns
	 $_SEP = $w3->getSkinObj()->getSeparator();
	 $language_form = "<form name=\"wm3_form\" method=\"post\" action=\"".WM3_cCONFIG_ADMIN_FILE."\">
			            ".$w3->getword(56)." ".wm3Language::selectLanguage($w3,'languageID',$w3->getAdminLanguage())." <input type=\"submit\" name=\"send\" value=\"".$w3->getWord(29)."\">
                        <input type=\"hidden\" name=\"stage\"  value=\"".WM3_cSTAGE_ADMIN."\">
                        <input type=\"hidden\" name=\"action\" value=\"".WM3_cACTION_CHANGE_LANGUAGE."\">
                       </form>";
     array_push($_CONTENTS,"$welcome $_SEP $previous_login");
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$language_form);

     // Create list caption // TODO "Quick link menu" label
     $str .= wm3Section::makeCaptionList($w3,$_WIDTHS,array(194,-1,-1,-1),0);

     // Admin home bar
	 $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
	 $webmatic_info = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_WEBMATIC_INFORMATIONS,"misc_info.png","Webmatic informations","","",0,16,16);
     $user_messages_label = wm3UserMessage::makeNotReadUserMessage($w3,889,$w3->getAuthenticateAdminID());
     $user_messages = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USER_MESSAGES,"misc_message.png","","",$user_messages_label,0,15,10);
     array_push($_CONTENTS,$webmatic_info." $_SEP ".$user_messages."<br><br>");
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(4));

	 // Render quick links
     for($i = 0; $i < $rows; $i++)
      {
	   $_CONTENTS = array();
       for($j = 0; $j < $columns; $j++)
        {
		 $p = $j + $i * $columns;
         if($p < $n) array_push($_CONTENTS,$_QUICK_MENU[$p]);
         else        array_push($_CONTENTS,"");
        }
	   $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false);
      }

     // Create bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     //require(WM3_cPATH_INCLUDE."admin_page_form.inc");
     return $str;
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_PAGE:
        {
         wm3Page::disablePage($w3->getVariable('pageID','get'));
         return wm3Page::getPageList($w3,$w3->getVariable('pageID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_PAGE:
        {
         wm3Page::enablePage($w3->getVariable('pageID','get'));
         return wm3Page::getPageList($w3,$w3->getVariable('pageID','get'));
         break;
        }
       case WM3_cACTION_DELETE_PAGE:
        {
         wm3Page::deletePage($w3->getVariable('pageID','get'));
         return wm3Page::getPageList($w3);
         break;
        }
       case WM3_cACTION_ADD_PAGE:
        {
         return wm3Page::addPage($w3);
         break;
        }
       case WM3_cACTION_SAVE_PAGE:
        {
         $error = wm3Page::checkPageError($w3);
         if(!$error)
          {
           $lastID = wm3Page::savePage($w3);
           // $msg= page saved... //TODO
           return wm3Page::getPageList($w3,$lastID);
          }
         else return wm3Page::addPage($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_PAGE:
        {
         return wm3Page::editPage($w3);
         break;
        }
       case WM3_cACTION_UPDATE_PAGE:
        {
         $error = wm3Page::checkPageError($w3);
         if(!$error)
          {
           $lastID = wm3Page::updatePage($w3);
           // $msg= page udated... //TODO
           return wm3Page::getPageList($w3,$lastID);
          }
         else return wm3Page::editPage($w3,$error);
         break;
        }
       case WM3_cACTION_DUPLICATE_PAGE:
        {
         $lastID = wm3Page::duplicatePage($w3);
         // $msg= page duplicated... //TODO
         return wm3Page::getPageList($w3,$lastID);
         break;
        }
       default:
        {
         return wm3Page::getPageList($w3);
        }
      }
    }

   public static function getPageList($w3,$currentID = 0,$admin = true)
    {
     // Get pages list

     // Prepare variables to create the list
     $max_page_items = 12;	 
     $columns = 7; $buttons = 4;
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE body LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY pageID";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'pageID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_page_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(1035));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(40,30,30,0),array(1408,1409,1407),$buttons);                    

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&pageID=$row->pageID";
       if($row->visibility == WM3_cPAGE_VISIBILITY_ALL)   $visibility_label = $w3->getWord(935);
       if($row->visibility == WM3_cPAGE_VISIBILITY_USERS) $visibility_label = $w3->getWord(936);
       if($row->visibility == WM3_cPAGE_VISIBILITY_GROUP) $visibility_label = $w3->getWord(1334);
       $group_label = wm3User::getGroupName($row->groupID);
       if($row->categoryID == 0) $type_label = $w3->getWord(544); // Custom page
       else                      $type_label = $w3->getLanguageObj()->translate(wm3Page::getPageCategoryName($row->categoryID));
       array_push($_CONTENTS,wm3Page::makePageLink($row->pageID,$row->title));
       array_push($_CONTENTS,"$type_label<br>(".$w3->getWord(1249).": $group_label)");
       array_push($_CONTENTS,$w3->getWord(934).": $visibility_label<br>(hits $row->hits)");
       array_push($_WIDTHS,40,30,30);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_PAGE,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_PAGE,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_PAGE,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_PAGE,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_PAGE,"action_delete.png",$w3->getWord(179),$w3->getWord(712)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->pageID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkPageError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray());
     if($_FIELD['title']=='') return 1;
     if(!wm3Page::existsPage($_FIELD['backID']) && $_FIELD['backID'] != 0) return 2;
     if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_EXPANSION && !isset($_FIELD['expansion'])) return 3;
     return 0;
    }

   public static function addPage($w3,$error = 0)
    {
     // Take variables value and set correct form style
     $_STYLE = wm3Skin::getFormStyleArray(wm3Page::getPageFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray());

     // Hide/Show correct field and error
     $_EXTRA_STYLE['expansion'] = $_EXTRA_STYLE['body'] = "style=\"display:none\"";
	 if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_EXPANSION) $_EXTRA_STYLE['expansion'] = "";
	 if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_CUSTOM)    $_EXTRA_STYLE['body']      = "";

     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Bad backID
        {
         $_STYLE['backID']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Previous page do not exists";//$w3->getWord(2);
         break;
        }
       case 3: // No expansion found
        {
         $_STYLE['expansion'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "No expansion found";//$w3->getWord(9);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled']              = WM3_cENABLED;
         $_FIELD['left_panels_enabled']  = WM3_cENABLED;
         $_FIELD['right_panels_enabled'] = WM3_cENABLED;
		 $_EXTRA_STYLE['body'] = "";
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(164);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_PAGE; 
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_page_form.inc");
     return $content;
    }

   public static function editPage($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                               WHERE pageID = '".$w3->getVariable('pageID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Page::getPageFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Page::getPageFieldsArray());

     // Hide/Show correct field and error
     $_EXTRA_STYLE['expansion'] = $_EXTRA_STYLE['body'] = "style=\"display:none\"";
	 if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_EXPANSION) $_EXTRA_STYLE['expansion'] = "";
	 if($_FIELD['categoryID'] == WM3_cPAGE_CATEGORY_CUSTOM)    $_EXTRA_STYLE['body']      = "";

     switch($error)
      {
       case 1: // No title 
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Bad backID
        {
         $_STYLE['backID']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Previous page do not exists";//$w3->getWord(2);
         break;
        }
       case 3: // No expansion found
        {
         $_STYLE['expansion'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "No expansion found";//$w3->getWord(2);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Insert new page"; //$w3->getWord(2);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_PAGE;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_page_form.inc");
     return $content;
    }

   public static function savePage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_pages',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updatePage($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Page::getPageFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                       SET title                = '".$_FIELD['title']."',
                           subtitle             = '".$_FIELD['subtitle']."',
                           head                 = '".$_FIELD['head']."',
                           body                 = '".$_FIELD['body']."',
                           foot                 = '".$_FIELD['foot']."',
						   expansion            = '".$_FIELD['expansion']."',
                           enabled              = '".$_FIELD['enabled']."',
                           categoryID           = '".$_FIELD['categoryID']."',
                           page_type            = '".$_FIELD['page_type']."',
                           visibility           = '".$_FIELD['visibility']."',
                           groupID              = '".$_FIELD['groupID']."',
                           backID               = '".$_FIELD['backID']."',
                           left_panels_enabled  = '".$_FIELD['left_panels_enabled']."',
                           right_panels_enabled = '".$_FIELD['right_panels_enabled']."',
						   render_mode          = '".$_FIELD['render_mode']."'
                       WHERE pageID             = '".$_FIELD['pageID']."'");
     return $_FIELD['pageID'];
    }

   public static function duplicatePage($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                             WHERE pageID = '".$w3->getVariable('pageID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Page::getPageFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['title']   = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['hits']    = 0;
       $_FIELD['ts']      = time();
       wm3Sql::saveAllTableFields('_pages',$_FIELD);
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disablePage($pageID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages SET enabled = '".WM3_cDISABLED."' WHERE pageID = '$pageID'"); }

   public static function enablePage($pageID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages SET enabled = '".WM3_cENABLED."'  WHERE pageID = '$pageID'"); }

   public static function deletePage($pageID) 
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_pages WRITE");
     $rs = wm3Sql::sqlQuery("SELECT backID FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'");
     if(mysql_num_rows($rs) == 1)
      {
       $row = mysql_fetch_object($rs);
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages SET backID = '$row->backID' WHERE backID = '$pageID'");
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_pages WHERE pageID = '$pageID'");
      }
	 wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function selectPage($name,$pageID,$none = false)
    {
     // Make pages select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages");
     $i = 0;
     if($none) { $_LABEL[0] = "No page"; $_VALUE[0] = 0; $i++; } // Used for backID
     while($row = mysql_fetch_object($rs))
      {
       $_LABEL[$i] = $row->title;
       $_VALUE[$i] = $row->pageID;
       $i++;
      }
     if($i != 0) return wm3Util::selectArray($name,$_LABEL,$_VALUE,$pageID);
    }

   public static function selectPageCategory($w3,$name,$categoryID,$js = "")
    {
     // Make page categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                             ORDER BY position DESC, name");
     $i = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_LABEL[$i] = $w3->getLanguageObj()->translate($row->name);
       $_VALUE[$i] = $row->categoryID;
       $i++;
      }
     return wm3Util::selectArray($name,$_LABEL,$_VALUE,$categoryID,$js);
    }

   public static function selectPageType($name,$page_type,$w3)
    {
     // Make page type select
     return wm3Util::selectArray($name,
                        array($w3->getWord(466),$w3->getWord(467)),
                        array(WM3_cPAGE_TYPE_CHANNELS,WM3_cPAGE_TYPE_NORMAL),
                        $page_type);
    }

   public static function selectPageVisibility($name,$visibility,$w3)
    {
     // Make page visibility select
     return wm3Util::selectArray($name,
                        array($w3->getWord(935),$w3->getWord(936),$w3->getWord(1334)),
                        array(WM3_cPAGE_VISIBILITY_ALL,WM3_cPAGE_VISIBILITY_USERS,WM3_cPAGE_VISIBILITY_GROUP),
                        $visibility);
    }

   public static function getPageCategoryName($categoryID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                             WHERE categoryID = '$categoryID'");
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function checkPageAccessError($w3,$pageID)
    {
     // Check access permissions for a page
	 $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                             WHERE pageID = '$pageID'");
     if(mysql_num_rows($rs) != 1) return 1; // Page do not exists
	 if(wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES)) return 0; // Access granted
	 $row = mysql_fetch_object($rs);
	 if($row->enabled == WM3_cDISABLED) return 2; // Page disabled
	 if($row->visibility == WM3_cPAGE_VISIBILITY_ALL) return 0; // Access granted
	 if($row->visibility == WM3_cPAGE_VISIBILITY_USERS && !$w3->getAuthenticateUserID()) return 3; // Access denied
	 if($row->visibility == WM3_cPAGE_VISIBILITY_GROUP && $row->groupID != wm3User::getGroupID($w3->getAuthenticateUserID())) return 3; // Access denied
    }

   public static function hitPage($w3)
    {
     $pageID = $w3->getVariable('pageID','get');
	 if(!wm3Session::pageAllowed($pageID,WM3_cSESSION_HIT)) return;
	 else wm3Session::pageProtect($pageID,WM3_cSESSION_HIT);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                       SET    hits = hits + 1
                       WHERE  pageID = '$pageID'");
    }

   public function isColumnEmpty($align) 
    {
     if($align == WM3_cPANEL_LEFT)  return $this->column_empty_left;
     if($align == WM3_cPANEL_RIGHT) return $this->column_empty_right;
    }

   public function hidePanelsActionHome($w3)
    {
	 // Hide left/right panels if an home action its performed (take values from preferences)
     $this->column_empty_left = $w3->getPreferences('hide_left_panels_action_home');
     $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_LEFT,$this->column_empty_left);
     $this->column_empty_right = $w3->getPreferences('hide_right_panels_action_home');
     $w3->getPanelObj()->setColumnEmpty(WM3_cPANEL_RIGHT,$this->column_empty_right);
	}

   public function existsPage($pageID)
    {
     // Return true if the page with pageID exists else return false
     $rs = wm3Sql::sqlQuery("SELECT pageID FROM ".WM3_cCONFIG_DB_PREFIX."_pages
                             WHERE  pageID = '$pageID'");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
	}

   public function getPageID()      { return $this->pageID; }

   public function setPageID($id)   { $this->pageID = $id; }

   public function setTitle($t)     { $this->title = $t; }

   public function setSubTitle($st) { $this->subtitle = $st; }
   
   public function setPageContent($st) { $this->html = $st; }

   public function setRenderHeadFoot($b) { $this->render_head_foot = $b; }

  }

?>
