<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3SearchEngine
  {

   function __construct() { }

   public static function getSearchEngineItemFieldsArray()
    {
     return array('search_engine_itemID','url','keywords','description','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_SEARCH_ENGINE_ITEM:
        {
         $error = wm3SearchEngine::checkSearchEngineItemError($w3,false);
         if(!$error)
          {
           $lastID = wm3SearchEngine::saveNewWebsite($w3);
           return wm3SearchEngine::completeNewWebsite($w3,$lastID);
          }
         else return wm3SearchEngine::addNewWebsite($w3,$error);
         break;
        }
       default:
        {
         return wm3SearchEngine::addNewWebsite($w3);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_SEARCH_ENGINE_ITEM:
        {
         wm3SearchEngine::disableSearchEngineItem($w3->getVariable('search_engine_itemID','get'));
         return wm3SearchEngine::getSearchEngineItemList($w3,$w3->getVariable('search_engine_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_SEARCH_ENGINE_ITEM:
        {
         wm3SearchEngine::enableSearchEngineItem($w3->getVariable('search_engine_itemID','get'));
         return wm3SearchEngine::getSearchEngineItemList($w3,$w3->getVariable('search_engine_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_SEARCH_ENGINE_ITEM:
        {
         wm3SearchEngine::deleteSearchEngineItem($w3->getVariable('search_engine_itemID','get'));
         return wm3SearchEngine::getSearchEngineItemList($w3);
         break;
        }		
       case WM3_cACTION_ADD_SEARCH_ENGINE_ITEM:
        {
         return wm3SearchEngine::addSearchEngineItem($w3);
         break;
        }
       case WM3_cACTION_SAVE_SEARCH_ENGINE_ITEM:
        {
         $error = wm3SearchEngine::checkSearchEngineItemError($w3);
         if(!$error)
          {
           $lastID = wm3SearchEngine::saveSearchEngineItem($w3);
           // $msg= message saved... //TODO
           return wm3SearchEngine::getSearchEngineItemList($w3,$lastID);
          }
         else return wm3SearchEngine::addSearchEngineItem($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM:
        {
         return wm3SearchEngine::editSearchEngineItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_SEARCH_ENGINE_ITEM:
        {
         $error = wm3SearchEngine::checkSearchEngineItemError($w3);
         if(!$error)
          {
           $lastID = wm3SearchEngine::updateSearchEngineItem($w3);
           // $msg= message udated... //TODO
           return wm3SearchEngine::getSearchEngineItemList($w3,$lastID);
          }
         else return wm3SearchEngine::editSearchEngineItem($w3,$error);
         break;
        }
       default:
        {
         return wm3SearchEngine::getSearchEngineItemList($w3);
        }
      }     
    }

   public static function getSearchEngineItemList($w3,$currentID = 0,$admin = true)
    {
     // Get search engine items list
     $max_page_items = 12; $columns = 5; $buttons = 3;
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter) {
		          $search_link = "&filter=$filter";
     	          $query_filter = "WHERE url LIKE '%$filter%' OR description LIKE '%$filter%' OR keywords LIKE '%$filter%'";
				 }
     else        { $search_link = $query_filter = ""; }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY url DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'search_engine_itemID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_search_engine_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(85));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(50,50,0),array(225,1213),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();       
       $link = $base_link.$id_link.$extra_link."&search_engine_itemID=$row->search_engine_itemID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
       array_push($_CONTENTS,"<a href=\"$row->url\" target=\"_blank\">$row->url</a>");
       array_push($_CONTENTS,"$lang_flag<br>Keywords: $row->keywords");
       array_push($_WIDTHS,50,50);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_SEARCH_ENGINE_ITEM,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_SEARCH_ENGINE_ITEM,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_SEARCH_ENGINE_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));       
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->search_engine_itemID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkSearchEngineItemError($w3,$admin = true)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
	 if($admin) { if(!wm3Util::isUrl($_FIELD['url']) && !wm3Util::isUrlRelative($_FIELD['url'])) return 1; }
     else       { if(!wm3Util::isUrl($_FIELD['url']))                                            return 1; }
	 if(wm3Sql::existValue(WM3_cCONFIG_DB_PREFIX."_search_engines_items","url",$_FIELD['url'],"search_engine_itemID",$_FIELD['search_engine_itemID'])) return 2;
     return 0;
    }

   public static function addSearchEngineItem($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // No url
        {
         $_STYLE['url']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Bad URL";
         break;
        }
       case 2: // Url already exist
        {
         $_STYLE['url']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."URL already exists";
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(341);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_SEARCH_ENGINE_ITEM;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_search_engine_item_form.inc");
     return $content;
    }

   public static function editSearchEngineItem($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                               WHERE search_engine_itemID = '".$w3->getVariable('search_engine_itemID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No url
        {
         $_STYLE['url']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Bad URL";
         break;
        }
       case 2: // Url already exist 
        {
         $_STYLE['url']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."URL already exists";
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit URL";//$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_SEARCH_ENGINE_ITEM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_search_engine_item_form.inc");
     return $content;
    }

   public static function saveSearchEngineItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_search_engines_items',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateSearchEngineItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                       SET   url                  = '".$_FIELD['url']."',
							 keywords             = '".$_FIELD['keywords']."',
							 description          = '".$_FIELD['description']."',
                             enabled              = '".$_FIELD['enabled']."',
                             languageID           = '".$_FIELD['languageID']."'
                       WHERE search_engine_itemID = '".$_FIELD['search_engine_itemID']."'");
     return $_FIELD['search_engine_itemID'];
    }

   public static function disableSearchEngineItem($search_engine_itemID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items SET enabled = '".WM3_cDISABLED."' WHERE search_engine_itemID = '$search_engine_itemID'");
	}

   public static function enableSearchEngineItem($search_engine_itemID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items SET enabled = '".WM3_cENABLED."' WHERE search_engine_itemID = '$search_engine_itemID'");
    }
   
   public static function deleteSearchEngineItem($search_engine_itemID)
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items WHERE search_engine_itemID = '$search_engine_itemID'");
    }

   public static function renderUserSearch($w3)
    {		
     // Render search panel in home page
     $columns = 2; $buttons = 0;
     $link = WM3_cCONFIG_HOME_FILE;

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Create search panel form
     $filter       = $w3->getVariable('filter','both');
	 $filter_check = $w3->getVariable('filter_check','both');
     $label_search         = $w3->getWord(292);
     $label_deep           = $w3->getWord(293);
	 $search               = wm3Util::inputText('filter',$filter,14);
	 $deep                 = "<div align=\"right\">".wm3Util::checkboxEnabled('filter_check',$filter_check)."</div>";
     $button_search        = "<div align=\"center\"><input type=\"submit\" name=\"send\" value=\"".$w3->getWord(291)."\"></div>";
     $str .= "<form name=\"wm3_form\" method=\"post\" action=\"$link\">";
     $str .= wm3Section::makeItemList($w3,0,array(0,100),array($label_search,$search),false);
     $str .= wm3Section::makeItemList($w3,1,array(0,100),array($deep,$label_deep),false);
     $str .= wm3Section::makeItemList($w3,0,array(100),array($button_search),false,array(2));
	 $str .= "<input type=\"hidden\" name=\"action\" value=\"".WM3_cACTION_SEARCH."\">";
     $str .= "</form>";
	 if($w3->getPreferences('show_total_search_engine'))
	  {
       $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE);
       if($allowed) {
	                 $total          = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items');
	                 $total_disabled = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cDISABLED."'");
				     $total_enabled  = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = "<br>".$w3->getWord(694)." $total<br>($total_disabled disabled, $total_enabled enabled)";
			        }
       else         {
	                 $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = "<br>".$w3->getWord(694)." $total";
		            }
	   $str .= wm3Section::makeItemList($w3,0,array(100),array($label),false,array(2));
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderUserSearchResult($w3)
    {
     // Render search result (home side)
     $max_page_items = 12; $columns = 2; $buttons = 0;
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter) $search_link = "&filter=$filter";
     else        $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
	 // TODO deep search che farà ???
	 if(!$filter)
	  $query = "SELECT 1 LIMIT 0,0";
	 else
      $query = "SELECT
                 ".WM3_cCONFIG_DB_PREFIX."_pages.pageID      AS ID,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.title       AS title_url,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.render_mode AS render_mode,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.subtitle    AS subtitle_keywords,
    		     ".WM3_cCONFIG_DB_PREFIX."_pages.head        AS head,
	    	     ".WM3_cCONFIG_DB_PREFIX."_pages.body        AS content,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.foot        AS foot,
	    	     ".WM3_cCONFIG_DB_PREFIX."_pages.languageID  AS languageID,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.enabled     AS enabled,
		         '".WM3_cSECTION_PAGES."'                    AS type
		        FROM
                 ".WM3_cCONFIG_DB_PREFIX."_pages
		        WHERE
		         ".WM3_cCONFIG_DB_PREFIX."_pages.enabled = '".WM3_cENABLED."' AND
		         (".WM3_cCONFIG_DB_PREFIX."_pages.title    LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.subtitle LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.head     LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.body     LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.foot     LIKE '%$filter%')
		   
		        UNION
		  
		        SELECT
                 ".WM3_cCONFIG_DB_PREFIX."_news.newsID      AS ID,
		         ".WM3_cCONFIG_DB_PREFIX."_news.title       AS title_url,
		         ".WM3_cCONFIG_DB_PREFIX."_news.render_mode AS render_mode,
		         ''                                         AS subtitle_keywords,
		         ''                                         AS head,
		         ".WM3_cCONFIG_DB_PREFIX."_news.news        AS content,
		         ''                                         AS foot,
		         ".WM3_cCONFIG_DB_PREFIX."_news.languageID  AS languageID,
		         ".WM3_cCONFIG_DB_PREFIX."_news.enabled     AS enabled,
		         '".WM3_cSECTION_NEWS."'                    AS type
		        FROM
                 ".WM3_cCONFIG_DB_PREFIX."_news
		        WHERE
		         ".WM3_cCONFIG_DB_PREFIX."_news.enabled = '".WM3_cENABLED."' AND
		         (".WM3_cCONFIG_DB_PREFIX."_news.title LIKE '%$filter%' OR
		          ".WM3_cCONFIG_DB_PREFIX."_news.news  LIKE '%$filter%')

                UNION

                SELECT
                 ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.search_engine_itemID AS ID,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.url                  AS title_url,
		         ''                                                                  AS render_mode,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.keywords             AS subtitle_keywords,
                 ''                                                                  AS head,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.description          AS content,
		         ''                                                                  AS foot,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.languageID           AS languageID,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.enabled              AS enabled,
		         '".WM3_cSECTION_SEARCH_ENGINE."'                                    AS type
		        FROM
                 ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
		        WHERE
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.enabled = '".WM3_cENABLED."' AND
		         (".WM3_cCONFIG_DB_PREFIX."_search_engines_items.url         LIKE '%$filter%' OR
		          ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.keywords    LIKE '%$filter%' OR
		          ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.description LIKE '%$filter%')
               ";
/*     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
               $query_filter";*/
	 $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Set page subtitle
     $w3->getPageObj()->setSubTitle($w3->getWord(525)." \"".wm3Util::renderContent($w3,$filter,WM3_cRENDER_MODE_PLAIN_TEXT)."\" (".$w3->getWord(526)." $total_items)");

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),$columns);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {       
       $link = $base_link.$id_link.$extra_link."&search_engine_itemID=$row->ID";
	   $n = "<b>".($p+1+$max_page_items*$pg).".</b>";
	   if($row->type == WM3_cSECTION_PAGES)
        {
		 $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $url       = wm3Page::makePageLink($row->ID,$row->title_url)." ($lang_flag)"; // TODO fare target _blank
         $content   = $row->content;
		} 
	   if($row->type == WM3_cSECTION_NEWS)
        {
		 $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $news_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS."&newsID=$row->ID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
         $url       = "<a href=\"$news_link\" target=\"_blank\">".wm3Util::renderContent($w3,$row->title_url,$row->render_mode)."</a> ($lang_flag)";
         $content   = $row->content;
		}
	   if($row->type == WM3_cSECTION_SEARCH_ENGINE)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $url     = "<a href=\"$row->title_url\" target=\"_blank\">$row->title_url</a> ($lang_flag)";
         $content = $row->content;
		}
       // Buttons
       //if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM,"action_edit.png",$w3->getWord(178)));
	   $content = strip_tags($content);
	   $lenght = 250;
	   $position = stripos($content,$filter);
	   $start = $position - $lenght; if($start < 0) $start = 0;
	   $end = $position + $lenght + strlen($filter);
	   $content = substr($content,$start,$end);
	   $content = str_replace($filter,"<b>$filter</b>",$content);
       $str .= wm3Section::makeItemList($w3,$p,array(0,100),array($n,$url),false);
	   $str .= wm3Section::makeItemList($w3,$p,array(100),array($content),false,array(2));
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link."&action=".WM3_cACTION_SEARCH);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function addNewWebsite($w3,$error = 0)
    {
     // Take variables value and set correct form style for add new website page (home side)
     $_STYLE = wm3Skin::getFormStyleArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
     switch($error)
      {
       case 1: // No url 
        {
         $_STYLE['url']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."Bad URL";
         break;
        }
       case 2: // Url already exist 
        {
         $_STYLE['url']       = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(-1)."URL already exists";
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cDISABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(87);
       	}
      }
     $_FIELD['pageID']  = $w3->getVariable('pageID','both'); // Take pageID from both
     $next_action       = WM3_cACTION_ADD_SEARCH_ENGINE_ITEM; 
     $next_action_label = $w3->getWord(294);
     require(WM3_cPATH_INCLUDE."home_new_website_form.inc");
     return $home_content;
    }

   public static function saveNewWebsite($w3)
    {
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));     

       $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['enabled'] = 1;// TODO get from database
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_search_engines_items',$_FIELD);
      }
     return wm3Sql::getLastInsertID();
    }

   public static function completeNewWebsite($w3,$lastID)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($lastID)
      {
       $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);

       //TODO
       $home_content = "TODO: Website added or updated<br><br>";
	   $home_content .= "Url: <b>".$_FIELD['url']."</b><br>";
       $home_content .= "Keywords: <b>".$_FIELD['keywords']."</b><br>";
	   $home_content .= "Description: <b>".wm3Util::renderContent($w3,$_FIELD['description'],WM3_cRENDER_MODE_PLAIN_TEXT)."</b><br>";
       $home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">Return to homepage</a>";
      }
     else
      {
       $home_content = "TODO Error di registrazione o cosa???"; // ???      	
      }
     return $home_content;
    }

  }

?>
